!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 127

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(858)
  integer, parameter :: nGC_3228 = 1
  integer, parameter :: nGC_3227 = 2
  integer, parameter :: nGC_3225 = 3
  integer, parameter :: nGC_3224 = 4
  integer, parameter :: nGC_3222 = 5
  integer, parameter :: nGC_3221 = 6
  integer, parameter :: nGC_3388 = 7
  integer, parameter :: nGC_3389 = 8
  integer, parameter :: nGC_3380 = 9
  integer, parameter :: nGC_3381 = 10
  integer, parameter :: nGC_3382 = 11
  integer, parameter :: nGC_3383 = 12
  integer, parameter :: nGC_3384 = 13
  integer, parameter :: nGC_3385 = 14
  integer, parameter :: nGC_3386 = 15
  integer, parameter :: nGC_3387 = 16
  integer, parameter :: nGC_3313 = 17
  integer, parameter :: nGC_3312 = 18
  integer, parameter :: nGC_3258 = 19
  integer, parameter :: nGC_3259 = 20
  integer, parameter :: nGC_3317 = 21
  integer, parameter :: nGC_3316 = 22
  integer, parameter :: nGC_3315 = 23
  integer, parameter :: nGC_3314 = 24
  integer, parameter :: nGC_3252 = 25
  integer, parameter :: nGC_3253 = 26
  integer, parameter :: nGC_3250 = 27
  integer, parameter :: nGC_3256 = 28
  integer, parameter :: nGC_3254 = 29
  integer, parameter :: nGC_3255 = 30
  integer, parameter :: nGC_69 = 31
  integer, parameter :: nGC_3260 = 32
  integer, parameter :: nGC_MZ_GF = 33
  integer, parameter :: nGC_28 = 34
  integer, parameter :: nGC_29 = 35
  integer, parameter :: nGC_22 = 36
  integer, parameter :: nGC_23 = 37
  integer, parameter :: nGC_20 = 38
  integer, parameter :: nGC_21 = 39
  integer, parameter :: nGC_26 = 40
  integer, parameter :: nGC_27 = 41
  integer, parameter :: nGC_24 = 42
  integer, parameter :: nGC_25 = 43
  integer, parameter :: nGC_3181 = 44
  integer, parameter :: nGC_3242 = 45
  integer, parameter :: nGC_3346 = 46
  integer, parameter :: nGC_3347 = 47
  integer, parameter :: nGC_3341 = 48
  integer, parameter :: nGC_3342 = 49
  integer, parameter :: nGC_3343 = 50
  integer, parameter :: nGC_3311 = 51
  integer, parameter :: nGC_3465 = 52
  integer, parameter :: nGC_3464 = 53
  integer, parameter :: nGC_3466 = 54
  integer, parameter :: nGC_3461 = 55
  integer, parameter :: nGC_3463 = 56
  integer, parameter :: nGC_3462 = 57
  integer, parameter :: nGC_MMW_GF = 58
  integer, parameter :: nGC_3319 = 59
  integer, parameter :: nGC_3318 = 60
  integer, parameter :: nGC_3263 = 61
  integer, parameter :: nGC_3262 = 62
  integer, parameter :: nGC_3261 = 63
  integer, parameter :: nGC_3267 = 64
  integer, parameter :: nGC_3266 = 65
  integer, parameter :: nGC_3265 = 66
  integer, parameter :: nGC_3264 = 67
  integer, parameter :: nGC_3182 = 68
  integer, parameter :: nGC_3183 = 69
  integer, parameter :: nGC_3186 = 70
  integer, parameter :: nGC_3187 = 71
  integer, parameter :: nGC_3184 = 72
  integer, parameter :: nGC_3185 = 73
  integer, parameter :: nGC_71 = 74
  integer, parameter :: nGC_3165 = 75
  integer, parameter :: nGC_3166 = 76
  integer, parameter :: nGC_3160 = 77
  integer, parameter :: nGC_3161 = 78
  integer, parameter :: nGC_3163 = 79
  integer, parameter :: nGC_I = 80
  integer, parameter :: nGC_3168 = 81
  integer, parameter :: nGC_3169 = 82
  integer, parameter :: nGC_87 = 83
  integer, parameter :: nGC_70 = 84
  integer, parameter :: nGC_3310 = 85
  integer, parameter :: nGC_197 = 86
  integer, parameter :: nGC_193 = 87
  integer, parameter :: nGC_3323 = 88
  integer, parameter :: nGC_3 = 89
  integer, parameter :: nGC_2 = 90
  integer, parameter :: nGC_1 = 91
  integer, parameter :: nGC_7 = 92
  integer, parameter :: nGC_6 = 93
  integer, parameter :: nGC_5 = 94
  integer, parameter :: nGC_4 = 95
  integer, parameter :: nGC_9 = 96
  integer, parameter :: nGC_8 = 97
  integer, parameter :: nGC_TS_GC_71_H = 98
  integer, parameter :: nGC_MI = 99
  integer, parameter :: nGC_52 = 100
  integer, parameter :: nGC_51 = 101
  integer, parameter :: nGC_50 = 102
  integer, parameter :: nGC_57 = 103
  integer, parameter :: nGC_56 = 104
  integer, parameter :: nGC_55 = 105
  integer, parameter :: nGC_54 = 106
  integer, parameter :: nGC_59 = 107
  integer, parameter :: nGC_58 = 108
  integer, parameter :: nGC_46 = 109
  integer, parameter :: nGC_3455 = 110
  integer, parameter :: nGC_47 = 111
  integer, parameter :: nGC_3456 = 112
  integer, parameter :: nGC_MC = 113
  integer, parameter :: nGC_MB = 114
  integer, parameter :: nGC_3238 = 115
  integer, parameter :: nGC_3234 = 116
  integer, parameter :: nGC_3236 = 117
  integer, parameter :: nGC_3237 = 118
  integer, parameter :: nGC_3230 = 119
  integer, parameter :: nGC_3231 = 120
  integer, parameter :: nGC_3232 = 121
  integer, parameter :: nGC_3233 = 122
  integer, parameter :: nGC_2719 = 123
  integer, parameter :: nGC_MZ = 124
  integer, parameter :: nGC_3300 = 125
  integer, parameter :: nGC_3302 = 126
  integer, parameter :: nGC_3303 = 127
  integer, parameter :: nGC_3304 = 128
  integer, parameter :: nGC_3305 = 129
  integer, parameter :: nGC_3306 = 130
  integer, parameter :: nGC_3307 = 131
  integer, parameter :: nGC_3308 = 132
  integer, parameter :: nGC_3309 = 133
  integer, parameter :: nGC_5454 = 134
  integer, parameter :: nGC_5455 = 135
  integer, parameter :: nGC_60 = 136
  integer, parameter :: nGC_61 = 137
  integer, parameter :: nGC_3280 = 138
  integer, parameter :: nGC_3283 = 139
  integer, parameter :: nGC_3284 = 140
  integer, parameter :: nGC_3287 = 141
  integer, parameter :: nGC_3286 = 142
  integer, parameter :: nGC_3288 = 143
  integer, parameter :: nGC_5159 = 144
  integer, parameter :: nGC_5158 = 145
  integer, parameter :: nGC_7806 = 146
  integer, parameter :: nGC_7805 = 147
  integer, parameter :: nGC_3214 = 148
  integer, parameter :: nGC_TS_GC_52_H = 149
  integer, parameter :: nGC_4716 = 150
  integer, parameter :: nGC_4717 = 151
  integer, parameter :: nGC_17 = 152
  integer, parameter :: nGC_16 = 153
  integer, parameter :: nGC_15 = 154
  integer, parameter :: nGC_14 = 155
  integer, parameter :: nGC_13 = 156
  integer, parameter :: nGC_12 = 157
  integer, parameter :: nGC_11 = 158
  integer, parameter :: nGC_10 = 159
  integer, parameter :: nGC_19 = 160
  integer, parameter :: nGC_18 = 161
  integer, parameter :: nGC_3397 = 162
  integer, parameter :: nGC_3215 = 163
  integer, parameter :: nGC_1111 = 164
  integer, parameter :: nGC_3212 = 165
  integer, parameter :: nGC_3140 = 166
  integer, parameter :: nGC_413 = 167
  integer, parameter :: nGC_3378 = 168
  integer, parameter :: nGC_3371 = 169
  integer, parameter :: nGC_3373 = 170
  integer, parameter :: nGC_3372 = 171
  integer, parameter :: nGC_3374 = 172
  integer, parameter :: nGC_3376 = 173
  integer, parameter :: nGC_3207 = 174
  integer, parameter :: nGC_3141 = 175
  integer, parameter :: nGC_3206 = 176
  integer, parameter :: nGC_3196 = 177
  integer, parameter :: nGC_3193 = 178
  integer, parameter :: nGC_4942 = 179
  integer, parameter :: nGC_4941 = 180
  integer, parameter :: nGC_MH = 181
  integer, parameter :: nGC_5112 = 182
  integer, parameter :: nGC_5111 = 183
  integer, parameter :: nGC_5110 = 184
  integer, parameter :: nGC_3270 = 185
  integer, parameter :: nGC_3271 = 186
  integer, parameter :: nGC_3273 = 187
  integer, parameter :: nGC_3274 = 188
  integer, parameter :: nGC_3275 = 189
  integer, parameter :: nGC_3276 = 190
  integer, parameter :: nGC_3277 = 191
  integer, parameter :: nGC_3278 = 192
  integer, parameter :: nGC_3279 = 193
  integer, parameter :: nGC_3248 = 194
  integer, parameter :: nGC_3249 = 195
  integer, parameter :: nGC_3153 = 196
  integer, parameter :: nGC_3152 = 197
  integer, parameter :: nGC_3155 = 198
  integer, parameter :: nGC_3154 = 199
  integer, parameter :: nGC_3407 = 200
  integer, parameter :: nGC_3402 = 201
  integer, parameter :: nGC_3401 = 202
  integer, parameter :: nGC_3400 = 203
  integer, parameter :: nGC_221 = 204
  integer, parameter :: nGC_225 = 205
  integer, parameter :: nGC_MM = 206
  integer, parameter :: nGC_3087 = 207
  integer, parameter :: nGC_6785 = 208
  integer, parameter :: nGC_4752 = 209
  integer, parameter :: nGC_7492 = 210
  integer, parameter :: nGC_6784 = 211
  integer, parameter :: nGC_4756 = 212
  integer, parameter :: nGC_3170 = 213
  integer, parameter :: nGC_TS_GC_8_H = 214
  integer, parameter :: nGC_4678 = 215
  integer, parameter :: nGC_451 = 216
  integer, parameter :: nGC_5363 = 217
  integer, parameter :: nGC_3179 = 218
  integer, parameter :: nGC_TS_GC_46_H = 219
  integer, parameter :: nGC_3178 = 220
  integer, parameter :: nGC_6919 = 221
  integer, parameter :: nGC_6915 = 222
  integer, parameter :: nGC_6647 = 223
  integer, parameter :: nGC_48 = 224
  integer, parameter :: nGC_49 = 225
  integer, parameter :: nGC_44 = 226
  integer, parameter :: nGC_45 = 227
  integer, parameter :: nGC_5894 = 228
  integer, parameter :: nGC_5895 = 229
  integer, parameter :: nGC_40 = 230
  integer, parameter :: nGC_41 = 231
  integer, parameter :: nGC_42 = 232
  integer, parameter :: nGC_43 = 233
  integer, parameter :: nGC_3219 = 234
  integer, parameter :: nGC_685 = 235
  integer, parameter :: nGC_7668 = 236
  integer, parameter :: nGC_3331 = 237
  integer, parameter :: nGC_5291 = 238
  integer, parameter :: nGC_5096 = 239
  integer, parameter :: nGC_2887 = 240
  integer, parameter :: nGC_3200 = 241
  integer, parameter :: nGC_3203 = 242
  integer, parameter :: nGC_3202 = 243
  integer, parameter :: nGC_3204 = 244
  integer, parameter :: nGC_3146 = 245
  integer, parameter :: nGC_3147 = 246
  integer, parameter :: nGC_3447 = 247
  integer, parameter :: nGC_3144 = 248
  integer, parameter :: nGC_3446 = 249
  integer, parameter :: nGC_3145 = 250
  integer, parameter :: nGC_3142 = 251
  integer, parameter :: nGC_3444 = 252
  integer, parameter :: nGC_3143 = 253
  integer, parameter :: nGC_4911 = 254
  integer, parameter :: nGC_3157 = 255
  integer, parameter :: nGC_3334 = 256
  integer, parameter :: nGC_3336 = 257
  integer, parameter :: nGC_3333 = 258
  integer, parameter :: nGC_3332 = 259
  integer, parameter :: nGC_3111 = 260
  integer, parameter :: nGC_3113 = 261
  integer, parameter :: nGC_3112 = 262
  integer, parameter :: nGC_3449 = 263
  integer, parameter :: nGC_3156 = 264
  integer, parameter :: nGC_3299 = 265
  integer, parameter :: nGC_3296 = 266
  integer, parameter :: nGC_3294 = 267
  integer, parameter :: nGC_3295 = 268
  integer, parameter :: nGC_3292 = 269
  integer, parameter :: nGC_3290 = 270
  integer, parameter :: nGC_3291 = 271
  integer, parameter :: nGC_ME = 272
  integer, parameter :: nGC_5147 = 273
  integer, parameter :: nGC_7669 = 274
  integer, parameter :: nGC_TS_GC_49_H = 275
  integer, parameter :: nGC_5635 = 276
  integer, parameter :: nGC_5633 = 277
  integer, parameter :: nGC_MD = 278
  integer, parameter :: nGC_3298 = 279
  integer, parameter :: nGC_TS_GC_21_H = 280
  integer, parameter :: nGC_3060 = 281
  integer, parameter :: nGC_3063 = 282
  integer, parameter :: nGC_3065 = 283
  integer, parameter :: nGC_3066 = 284
  integer, parameter :: nGC_7813 = 285
  integer, parameter :: nGC_313 = 286
  integer, parameter :: nGC_6359 = 287
  integer, parameter :: nGC_5604 = 288
  integer, parameter :: nGC_4765 = 289
  integer, parameter :: nGC_MTA = 290
  integer, parameter :: nGC_5600 = 291
  integer, parameter :: nGC_5553 = 292
  integer, parameter :: nGC_5967 = 293
  integer, parameter :: nGC_6704 = 294
  integer, parameter :: nGC_3335 = 295
  integer, parameter :: nGC_5968 = 296
  integer, parameter :: nGC_6920 = 297
  integer, parameter :: nGC_127 = 298
  integer, parameter :: nGC_75 = 299
  integer, parameter :: nGC_74 = 300
  integer, parameter :: nGC_76 = 301
  integer, parameter :: nGC_73 = 302
  integer, parameter :: nGC_72 = 303
  integer, parameter :: nGC_7630 = 304
  integer, parameter :: nGC_4959 = 305
  integer, parameter :: nGC_3448 = 306
  integer, parameter :: nGC_4951 = 307
  integer, parameter :: nGC_4952 = 308
  integer, parameter :: nGC_4954 = 309
  integer, parameter :: nGC_4955 = 310
  integer, parameter :: nGC_3399 = 311
  integer, parameter :: nGC_3398 = 312
  integer, parameter :: nGC_7416 = 313
  integer, parameter :: nGC_3392 = 314
  integer, parameter :: nGC_3390 = 315
  integer, parameter :: nGC_1113 = 316
  integer, parameter :: nGC_3396 = 317
  integer, parameter :: nGC_3395 = 318
  integer, parameter :: nGC_3394 = 319
  integer, parameter :: nGC_5102 = 320
  integer, parameter :: nGC_3366 = 321
  integer, parameter :: nGC_3367 = 322
  integer, parameter :: nGC_3361 = 323
  integer, parameter :: nGC_3245 = 324
  integer, parameter :: nGC_3244 = 325
  integer, parameter :: nGC_3246 = 326
  integer, parameter :: nGC_3241 = 327
  integer, parameter :: nGC_3240 = 328
  integer, parameter :: nGC_3368 = 329
  integer, parameter :: nGC_3369 = 330
  integer, parameter :: nGC_3026 = 331
  integer, parameter :: nGC_3020 = 332
  integer, parameter :: nGC_3023 = 333
  integer, parameter :: nGC_3022 = 334
  integer, parameter :: nGC_3029 = 335
  integer, parameter :: nGC_3148 = 336
  integer, parameter :: nGC_3149 = 337
  integer, parameter :: nGC_3417 = 338
  integer, parameter :: nGC_6585 = 339
  integer, parameter :: nGC_3411 = 340
  integer, parameter :: nGC_3412 = 341
  integer, parameter :: nGC_3413 = 342
  integer, parameter :: nGC_8732 = 343
  integer, parameter :: nGC_8733 = 344
  integer, parameter :: nGC_8736 = 345
  integer, parameter :: nGC_8737 = 346
  integer, parameter :: nGC_3097 = 347
  integer, parameter :: nGC_3098 = 348
  integer, parameter :: nGC_3099 = 349
  integer, parameter :: nGC_5959 = 350
  integer, parameter :: nGC_5460 = 351
  integer, parameter :: nGC_3101 = 352
  integer, parameter :: nGC_6450 = 353
  integer, parameter :: nGC_281 = 354
  integer, parameter :: nGC_TS_GC_48_H = 355
  integer, parameter :: nGC_363 = 356
  integer, parameter :: nGC_6001 = 357
  integer, parameter :: nGC_39 = 358
  integer, parameter :: nGC_7814 = 359
  integer, parameter :: nGC_TS_GC_20_H = 360
  integer, parameter :: nGC_31 = 361
  integer, parameter :: nGC_30 = 362
  integer, parameter :: nGC_33 = 363
  integer, parameter :: nGC_32 = 364
  integer, parameter :: nGC_35 = 365
  integer, parameter :: nGC_34 = 366
  integer, parameter :: nGC_37 = 367
  integer, parameter :: nGC_36 = 368
  integer, parameter :: nGC_7678 = 369
  integer, parameter :: nGC_4907 = 370
  integer, parameter :: nGC_4999 = 371
  integer, parameter :: nGC_4994 = 372
  integer, parameter :: nGC_4990 = 373
  integer, parameter :: nGC_4991 = 374
  integer, parameter :: nGC_7676 = 375
  integer, parameter :: nGC_7677 = 376
  integer, parameter :: nGC_3269 = 377
  integer, parameter :: nGC_TS_GC_27_H = 378
  integer, parameter :: nGC_67 = 379
  integer, parameter :: nGC_3356 = 380
  integer, parameter :: nGC_3167 = 381
  integer, parameter :: nGC_3351 = 382
  integer, parameter :: nGC_3350 = 383
  integer, parameter :: nGC_TS_GC_59_H = 384
  integer, parameter :: nGC_3189 = 385
  integer, parameter :: nGC_64 = 386
  integer, parameter :: nGC_3365 = 387
  integer, parameter :: nGC_3150 = 388
  integer, parameter :: nGC_TS_GC_87_H = 389
  integer, parameter :: nGC_3322 = 390
  integer, parameter :: nGC_3320 = 391
  integer, parameter :: nGC_3321 = 392
  integer, parameter :: nGC_3326 = 393
  integer, parameter :: nGC_3327 = 394
  integer, parameter :: nGC_3324 = 395
  integer, parameter :: nGC_3325 = 396
  integer, parameter :: nGC_3450 = 397
  integer, parameter :: nGC_3451 = 398
  integer, parameter :: nGC_3100 = 399
  integer, parameter :: nGC_3453 = 400
  integer, parameter :: nGC_3454 = 401
  integer, parameter :: nGC_3107 = 402
  integer, parameter :: nGC_3457 = 403
  integer, parameter :: nGC_3458 = 404
  integer, parameter :: nGC_3459 = 405
  integer, parameter :: nGC_3108 = 406
  integer, parameter :: nGC_6894 = 407
  integer, parameter :: nGC_6890 = 408
  integer, parameter :: nGC_3159 = 409
  integer, parameter :: nGC_3158 = 410
  integer, parameter :: nGC_MS = 411
  integer, parameter :: nGC_TS_GC_67_H = 412
  integer, parameter :: nGC_MW = 413
  integer, parameter :: nGC_MU = 414
  integer, parameter :: nGC_MT = 415
  integer, parameter :: nGC_6293 = 416
  integer, parameter :: nGC_3015 = 417
  integer, parameter :: nGC_3216 = 418
  integer, parameter :: nGC_3217 = 419
  integer, parameter :: nGC_3198 = 420
  integer, parameter :: nGC_3211 = 421
  integer, parameter :: nGC_3195 = 422
  integer, parameter :: nGC_3194 = 423
  integer, parameter :: nGC_3197 = 424
  integer, parameter :: nGC_3191 = 425
  integer, parameter :: nGC_3190 = 426
  integer, parameter :: nGC_3218 = 427
  integer, parameter :: nGC_MW_GF = 428
  integer, parameter :: nGC_3177 = 429
  integer, parameter :: nGC_3176 = 430
  integer, parameter :: nGC_3174 = 431
  integer, parameter :: nGC_3173 = 432
  integer, parameter :: nGC_3172 = 433
  integer, parameter :: nGC_3078 = 434
  integer, parameter :: nGC_3079 = 435
  integer, parameter :: nGC_3076 = 436
  integer, parameter :: nGC_3077 = 437
  integer, parameter :: nGC_3073 = 438
  integer, parameter :: nGC_3070 = 439
  integer, parameter :: nGC_6363 = 440
  integer, parameter :: nGC_38 = 441
  integer, parameter :: nGC_TS_GC_13_H = 442
  integer, parameter :: nGC_4776 = 443
  integer, parameter :: nGC_4777 = 444
  integer, parameter :: nGC_5829 = 445
  integer, parameter :: nGC_5828 = 446
  integer, parameter :: nGC_5826 = 447
  integer, parameter :: nGC_3120 = 448
  integer, parameter :: nGC_3121 = 449
  integer, parameter :: nGC_6888 = 450
  integer, parameter :: nGC_189 = 451
  integer, parameter :: nGC_3452 = 452
  integer, parameter :: nGC_5384 = 453
  integer, parameter :: nGC_4892 = 454
  integer, parameter :: nGC_88 = 455
  integer, parameter :: nGC_81 = 456
  integer, parameter :: nGC_82 = 457
  integer, parameter :: nGC_83 = 458
  integer, parameter :: nGC_84 = 459
  integer, parameter :: nGC_85 = 460
  integer, parameter :: nGC_86 = 461
  integer, parameter :: nGC_3460 = 462
  integer, parameter :: nGC_66 = 463
  integer, parameter :: nGC_7490 = 464
  integer, parameter :: nGC_6701 = 465
  integer, parameter :: nGC_65 = 466
  integer, parameter :: nGC_62 = 467
  integer, parameter :: nGC_63 = 468
  integer, parameter :: nGC_6705 = 469
  integer, parameter :: nGC_4743 = 470
  integer, parameter :: nGC_3089 = 471
  integer, parameter :: nGC_68 = 472
  integer, parameter :: nGC_3088 = 473
  integer, parameter :: nGC_4960 = 474
  integer, parameter :: nGC_4963 = 475
  integer, parameter :: nGC_4962 = 476
  integer, parameter :: nGC_3209 = 477
  integer, parameter :: nGC_4742 = 478
  integer, parameter :: nGC_4995 = 479
  integer, parameter :: nGC_4800 = 480
  integer, parameter :: nGC_8215 = 481
  integer, parameter :: nGC_3229 = 482
  integer, parameter :: nGC_3226 = 483
  integer, parameter :: nGC_3223 = 484
  integer, parameter :: nGC_3220 = 485
  integer, parameter :: nGC_1107 = 486
  integer, parameter :: nGC_5688 = 487
  integer, parameter :: nGC_5687 = 488
  integer, parameter :: nGC_TS_GC_50_H = 489
  integer, parameter :: nGC_5684 = 490
  integer, parameter :: nGC_5683 = 491
  integer, parameter :: nGC_3251 = 492
  integer, parameter :: nGC_3257 = 493
  integer, parameter :: nGC_3031 = 494
  integer, parameter :: nGC_3036 = 495
  integer, parameter :: nGC_3034 = 496
  integer, parameter :: nGC_3035 = 497
  integer, parameter :: nGC_4702 = 498
  integer, parameter :: nGC_4706 = 499
  integer, parameter :: nGC_3139 = 500
  integer, parameter :: nGC_3138 = 501
  integer, parameter :: nGC_3421 = 502
  integer, parameter :: nGC_3420 = 503
  integer, parameter :: nGC_3131 = 504
  integer, parameter :: nGC_3130 = 505
  integer, parameter :: nGC_3137 = 506
  integer, parameter :: nGC_3136 = 507
  integer, parameter :: nGC_3135 = 508
  integer, parameter :: nGC_3134 = 509
  integer, parameter :: nGC_5000 = 510
  integer, parameter :: nGC_4639 = 511
  integer, parameter :: nGC_4635 = 512
  integer, parameter :: nGC_4636 = 513
  integer, parameter :: nGC_4631 = 514
  integer, parameter :: nGC_4630 = 515
  integer, parameter :: nGC_4632 = 516
  integer, parameter :: nGC_TS_GC_15_H = 517
  integer, parameter :: nGC_5946 = 518
  integer, parameter :: nGC_3047 = 519
  integer, parameter :: nGC_3046 = 520
  integer, parameter :: nGC_3045 = 521
  integer, parameter :: nGC_3044 = 522
  integer, parameter :: nGC_3043 = 523
  integer, parameter :: nGC_5341 = 524
  integer, parameter :: nGC_4794 = 525
  integer, parameter :: nGC_3049 = 526
  integer, parameter :: nGC_3048 = 527
  integer, parameter :: nGC_7203 = 528
  integer, parameter :: nGC_3268 = 529
  integer, parameter :: nGC_4844 = 530
  integer, parameter :: nGC_3050 = 531
  integer, parameter :: nGC_TS_GC_17_H = 532
  integer, parameter :: nGC_3051 = 533
  integer, parameter :: nGC_3348 = 534
  integer, parameter :: nGC_3349 = 535
  integer, parameter :: nGC_3344 = 536
  integer, parameter :: nGC_3345 = 537
  integer, parameter :: nGC_3340 = 538
  integer, parameter :: nGC_5400 = 539
  integer, parameter :: nGC_4836 = 540
  integer, parameter :: nGC_4835 = 541
  integer, parameter :: nGC_4834 = 542
  integer, parameter :: nGC_3469 = 543
  integer, parameter :: nGC_3468 = 544
  integer, parameter :: nGC_3467 = 545
  integer, parameter :: nGC_8211 = 546
  integer, parameter :: nGC_TS_GC_55_H = 547
  integer, parameter :: nGC_5043 = 548
  integer, parameter :: nGC_3188 = 549
  integer, parameter :: nGC_5712 = 550
  integer, parameter :: nGC_3180 = 551
  integer, parameter :: nGC_5653 = 552
  integer, parameter :: nGC_5654 = 553
  integer, parameter :: nGC_3032 = 554
  integer, parameter :: nGC_3033 = 555
  integer, parameter :: nGC_3164 = 556
  integer, parameter :: nGC_4698 = 557
  integer, parameter :: nGC_3162 = 558
  integer, parameter :: nGC_9531 = 559
  integer, parameter :: nGC_9533 = 560
  integer, parameter :: nGC_235 = 561
  integer, parameter :: nGC_7488 = 562
  integer, parameter :: nGC_7484 = 563
  integer, parameter :: nGC_TS_GC_75_H = 564
  integer, parameter :: nGC_7680 = 565
  integer, parameter :: nGC_4889 = 566
  integer, parameter :: nGC_5374 = 567
  integer, parameter :: nGC_5902 = 568
  integer, parameter :: nGC_5903 = 569
  integer, parameter :: nGC_5904 = 570
  integer, parameter :: nGC_5905 = 571
  integer, parameter :: nGC_5906 = 572
  integer, parameter :: nGC_3133 = 573
  integer, parameter :: nGC_3132 = 574
  integer, parameter :: nGC_6651 = 575
  integer, parameter :: nGC_7489 = 576
  integer, parameter :: nGC_TS_GC_37_H = 577
  integer, parameter :: nGC_4871 = 578
  integer, parameter :: nGC_5286 = 579
  integer, parameter :: nGC_5285 = 580
  integer, parameter :: nGC_3109 = 581
  integer, parameter :: nGC_3239 = 582
  integer, parameter :: nGC_3235 = 583
  integer, parameter :: nGC_5122 = 584
  integer, parameter :: nGC_5126 = 585
  integer, parameter :: nGC_6005 = 586
  integer, parameter :: nGC_3301 = 587
  integer, parameter :: nGC_7485 = 588
  integer, parameter :: nGC_5459 = 589
  integer, parameter :: nGC_4909 = 590
  integer, parameter :: nGC_4908 = 591
  integer, parameter :: nGC_835 = 592
  integer, parameter :: nGC_3281 = 593
  integer, parameter :: nGC_3129 = 594
  integer, parameter :: nGC_3282 = 595
  integer, parameter :: nGC_3285 = 596
  integer, parameter :: nGC_7321 = 597
  integer, parameter :: nGC_3289 = 598
  integer, parameter :: nGC_3122 = 599
  integer, parameter :: nGC_3123 = 600
  integer, parameter :: nGC_3124 = 601
  integer, parameter :: nGC_3125 = 602
  integer, parameter :: nGC_3126 = 603
  integer, parameter :: nGC_3127 = 604
  integer, parameter :: nGC_5018 = 605
  integer, parameter :: nGC_5621 = 606
  integer, parameter :: nGC_5623 = 607
  integer, parameter :: nGC_5625 = 608
  integer, parameter :: nGC_5626 = 609
  integer, parameter :: nGC_5971 = 610
  integer, parameter :: nGC_5970 = 611
  integer, parameter :: nGC_3054 = 612
  integer, parameter :: nGC_3055 = 613
  integer, parameter :: nGC_3056 = 614
  integer, parameter :: nGC_3057 = 615
  integer, parameter :: nGC_5337 = 616
  integer, parameter :: nGC_5336 = 617
  integer, parameter :: nGC_3052 = 618
  integer, parameter :: nGC_3053 = 619
  integer, parameter :: nGC_3058 = 620
  integer, parameter :: nGC_3059 = 621
  integer, parameter :: nGC_469 = 622
  integer, parameter :: nGC_5176 = 623
  integer, parameter :: nGC_6343 = 624
  integer, parameter :: nGC_5097 = 625
  integer, parameter :: nGC_6617 = 626
  integer, parameter :: nGC_6616 = 627
  integer, parameter :: nGC_3379 = 628
  integer, parameter :: nGC_3370 = 629
  integer, parameter :: nGC_3375 = 630
  integer, parameter :: nGC_3377 = 631
  integer, parameter :: nGC_5416 = 632
  integer, parameter :: nGC_5418 = 633
  integer, parameter :: nGC_4944 = 634
  integer, parameter :: nGC_5050 = 635
  integer, parameter :: nGC_5779 = 636
  integer, parameter :: nGC_3272 = 637
  integer, parameter :: nGC_4729 = 638
  integer, parameter :: nGC_4728 = 639
  integer, parameter :: nGC_4727 = 640
  integer, parameter :: nGC_3151 = 641
  integer, parameter :: nGC_3019 = 642
  integer, parameter :: nGC_1423 = 643
  integer, parameter :: nGC_3409 = 644
  integer, parameter :: nGC_3408 = 645
  integer, parameter :: nGC_3406 = 646
  integer, parameter :: nGC_3405 = 647
  integer, parameter :: nGC_3404 = 648
  integer, parameter :: nGC_3403 = 649
  integer, parameter :: nGC_4686 = 650
  integer, parameter :: nGC_4687 = 651
  integer, parameter :: nGC_3083 = 652
  integer, parameter :: nGC_3082 = 653
  integer, parameter :: nGC_3081 = 654
  integer, parameter :: nGC_3080 = 655
  integer, parameter :: nGC_3086 = 656
  integer, parameter :: nGC_3085 = 657
  integer, parameter :: nGC_3084 = 658
  integer, parameter :: nGC_7491 = 659
  integer, parameter :: nGC_3021 = 660
  integer, parameter :: nGC_3339 = 661
  integer, parameter :: nGC_4981 = 662
  integer, parameter :: nGC_4863 = 663
  integer, parameter :: nGC_4864 = 664
  integer, parameter :: nGC_4866 = 665
  integer, parameter :: nGC_3208 = 666
  integer, parameter :: nGC_3201 = 667
  integer, parameter :: nGC_3205 = 668
  integer, parameter :: nGC_5098 = 669
  integer, parameter :: nGC_5099 = 670
  integer, parameter :: nGC_4910 = 671
  integer, parameter :: nGC_3338 = 672
  integer, parameter :: nGC_5423 = 673
  integer, parameter :: nGC_3337 = 674
  integer, parameter :: nGC_5588 = 675
  integer, parameter :: nGC_3330 = 676
  integer, parameter :: nGC_3115 = 677
  integer, parameter :: nGC_3114 = 678
  integer, parameter :: nGC_3117 = 679
  integer, parameter :: nGC_3116 = 680
  integer, parameter :: nGC_3110 = 681
  integer, parameter :: nGC_4640 = 682
  integer, parameter :: nGC_4647 = 683
  integer, parameter :: nGC_3119 = 684
  integer, parameter :: nGC_3118 = 685
  integer, parameter :: nGC_4642 = 686
  integer, parameter :: nGC_3297 = 687
  integer, parameter :: nGC_3293 = 688
  integer, parameter :: nGC_5066 = 689
  integer, parameter :: nGC_5639 = 690
  integer, parameter :: nGC_5738 = 691
  integer, parameter :: nGC_3061 = 692
  integer, parameter :: nGC_3062 = 693
  integer, parameter :: nGC_3064 = 694
  integer, parameter :: nGC_3067 = 695
  integer, parameter :: nGC_3069 = 696
  integer, parameter :: nGC_7815 = 697
  integer, parameter :: nGC_7816 = 698
  integer, parameter :: nGC_7817 = 699
  integer, parameter :: nGC_851 = 700
  integer, parameter :: nGC_TS_GC_63_H = 701
  integer, parameter :: nGC_3092 = 702
  integer, parameter :: nGC_4762 = 703
  integer, parameter :: nGC_4761 = 704
  integer, parameter :: nGC_3094 = 705
  integer, parameter :: nGC_5555 = 706
  integer, parameter :: nGC_5992 = 707
  integer, parameter :: nGC_5255 = 708
  integer, parameter :: nGC_5399 = 709
  integer, parameter :: nGC_5252 = 710
  integer, parameter :: nGC_7178 = 711
  integer, parameter :: nGC_5960 = 712
  integer, parameter :: nGC_5969 = 713
  integer, parameter :: nGC_5782 = 714
  integer, parameter :: nGC_5783 = 715
  integer, parameter :: nGC_5788 = 716
  integer, parameter :: nGC_4958 = 717
  integer, parameter :: nGC_4810 = 718
  integer, parameter :: nGC_4957 = 719
  integer, parameter :: nGC_3393 = 720
  integer, parameter :: nGC_3391 = 721
  integer, parameter :: nGC_3364 = 722
  integer, parameter :: nGC_5778 = 723
  integer, parameter :: nGC_3362 = 724
  integer, parameter :: nGC_3363 = 725
  integer, parameter :: nGC_3360 = 726
  integer, parameter :: nGC_3247 = 727
  integer, parameter :: nGC_3243 = 728
  integer, parameter :: nGC_3025 = 729
  integer, parameter :: nGC_3024 = 730
  integer, parameter :: nGC_3027 = 731
  integer, parameter :: nGC_4738 = 732
  integer, parameter :: nGC_4735 = 733
  integer, parameter :: nGC_3028 = 734
  integer, parameter :: nGC_3418 = 735
  integer, parameter :: nGC_3419 = 736
  integer, parameter :: nGC_3414 = 737
  integer, parameter :: nGC_3415 = 738
  integer, parameter :: nGC_3416 = 739
  integer, parameter :: nGC_3410 = 740
  integer, parameter :: nGC_6856 = 741
  integer, parameter :: nGC_5033 = 742
  integer, parameter :: nGC_3090 = 743
  integer, parameter :: nGC_3091 = 744
  integer, parameter :: nGC_5605 = 745
  integer, parameter :: nGC_3093 = 746
  integer, parameter :: nGC_6093 = 747
  integer, parameter :: nGC_3095 = 748
  integer, parameter :: nGC_3096 = 749
  integer, parameter :: nGC_TS_GC_83_H = 750
  integer, parameter :: nGC_4781 = 751
  integer, parameter :: nGC_4780 = 752
  integer, parameter :: nGC_5215 = 753
  integer, parameter :: nGC_5355 = 754
  integer, parameter :: nGC_5356 = 755
  integer, parameter :: nGC_6329 = 756
  integer, parameter :: nGC_3068 = 757
  integer, parameter :: nGC_7679 = 758
  integer, parameter :: nGC_4850 = 759
  integer, parameter :: nGC_5504 = 760
  integer, parameter :: nGC_5505 = 761
  integer, parameter :: nGC_5506 = 762
  integer, parameter :: nGC_4992 = 763
  integer, parameter :: nGC_5503 = 764
  integer, parameter :: nGC_5812 = 765
  integer, parameter :: nGC_3359 = 766
  integer, parameter :: nGC_3358 = 767
  integer, parameter :: nGC_3357 = 768
  integer, parameter :: nGC_3355 = 769
  integer, parameter :: nGC_3354 = 770
  integer, parameter :: nGC_3353 = 771
  integer, parameter :: nGC_3352 = 772
  integer, parameter :: nGC_5438 = 773
  integer, parameter :: nGC_3328 = 774
  integer, parameter :: nGC_3329 = 775
  integer, parameter :: nGC_5430 = 776
  integer, parameter :: nGC_5431 = 777
  integer, parameter :: nGC_3102 = 778
  integer, parameter :: nGC_3103 = 779
  integer, parameter :: nGC_3106 = 780
  integer, parameter :: nGC_3104 = 781
  integer, parameter :: nGC_3105 = 782
  integer, parameter :: nGC_6895 = 783
  integer, parameter :: nGC_4672 = 784
  integer, parameter :: nGC_4677 = 785
  integer, parameter :: nGC_4681 = 786
  integer, parameter :: nGC_5175 = 787
  integer, parameter :: nGC_655 = 788
  integer, parameter :: nGC_5072 = 789
  integer, parameter :: nGC_5073 = 790
  integer, parameter :: nGC_6294 = 791
  integer, parameter :: nGC_5076 = 792
  integer, parameter :: nGC_5649 = 793
  integer, parameter :: nGC_5648 = 794
  integer, parameter :: nGC_3199 = 795
  integer, parameter :: nGC_3213 = 796
  integer, parameter :: nGC_3210 = 797
  integer, parameter :: nGC_5640 = 798
  integer, parameter :: nGC_3192 = 799
  integer, parameter :: nGC_3175 = 800
  integer, parameter :: nGC_3171 = 801
  integer, parameter :: nGC_3074 = 802
  integer, parameter :: nGC_3075 = 803
  integer, parameter :: nGC_3072 = 804
  integer, parameter :: nGC_3071 = 805
  integer, parameter :: nGC_3128 = 806
  integer, parameter :: nGC_6169 = 807
  integer, parameter :: nGC_6524 = 808
  integer, parameter :: nGC_6702 = 809
  integer, parameter :: nGC_4809 = 810
  integer, parameter :: nGC_4804 = 811
  integer, parameter :: nGC_9267 = 812
  integer, parameter :: nGC_5419 = 813
  integer, parameter :: nGC_5554 = 814
  integer, parameter :: nGC_4651 = 815
  integer, parameter :: nGC_6053 = 816
  integer, parameter :: nGC_6858 = 817
  integer, parameter :: nGC_3042 = 818
  integer, parameter :: nGC_3041 = 819
  integer, parameter :: nGC_3040 = 820
  integer, parameter :: nGC_6857 = 821
  integer, parameter :: nGC_5138 = 822
  integer, parameter :: nGC_9263 = 823
  integer, parameter :: nGC_4664 = 824
  integer, parameter :: nGC_4662 = 825
  integer, parameter :: nGC_4663 = 826
  integer, parameter :: nGC_4938 = 827
  integer, parameter :: nGC_4833 = 828
  integer, parameter :: nGC_4668 = 829
  integer, parameter :: nGC_4748 = 830
  integer, parameter :: nGC_4709 = 831
  integer, parameter :: nGC_4708 = 832
  integer, parameter :: nGC_3030 = 833
  integer, parameter :: nGC_3037 = 834
  integer, parameter :: nGC_4701 = 835
  integer, parameter :: nGC_3038 = 836
  integer, parameter :: nGC_3039 = 837
  integer, parameter :: nGC_4840 = 838
  integer, parameter :: nGC_4643 = 839
  integer, parameter :: nGC_5552 = 840
  integer, parameter :: nGC_4732 = 841
  integer, parameter :: nGC_4937 = 842
  integer, parameter :: nGC_5128 = 843
  integer, parameter :: nGC_5129 = 844
  integer, parameter :: nGC_7210 = 845
  integer, parameter :: nGC_6008 = 846
  integer, parameter :: nGC_5417 = 847
  integer, parameter :: nGC_4987 = 848
  integer, parameter :: nGC_6007 = 849
  integer, parameter :: nGC_5690 = 850
  integer, parameter :: nGC_5691 = 851
  integer, parameter :: nGC_5737 = 852
  integer, parameter :: nGC_4820 = 853
  integer, parameter :: nGC_5719 = 854
  integer, parameter :: nGC_4928 = 855
  integer, parameter :: nGC_4865 = 856
  integer, parameter :: nGC_5739 = 857
  integer, parameter :: nGC_6618 = 858
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
