!******************************************************************************!
!                                                                              !
!    class_form.f90                                                            !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_form.f90                                 |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_form
  use class_particles, only: order_ids
  use class_vertices
  use input_mdl, only: complex_mass_frm, masscut_frm, error_mdl
  use fcFFa2, only: formFFa2
  use fcSSVV0, only: formSSVV0
  use fcVV2, only: formVV2
  use fcSS2, only: formSS2
  use fcFaFV0, only: formFaFV0
  use fcVS1, only: formVS1
  use fcFaF0, only: formFaF0
  use fcUaUS0, only: formUaUS0
  use fcFaSF0, only: formFaSF0
  use fcFVFa1, only: formFVFa1
  use fcVSS0, only: formVSS0
  use fcUaVU0, only: formUaVU0
  use fcSVS0, only: formSVS0
  use fcFFaS1, only: formFFaS1
  use fcSFaF0, only: formSFaF0
  use fcSFaF1, only: formSFaF1
  use fcSV1, only: formSV1
  use fcUaSU0, only: formUaSU0
  use fcVVSS0, only: formVVSS0
  use fcFaFS0, only: formFaFS0
  use fcVV1, only: formVV1
  use fcFFaS2, only: formFFaS2
  use fcSVSV0, only: formSVSV0
  use fcFaF3, only: formFaF3
  use fcFFaV0, only: formFFaV0
  use fcSS1, only: formSS1
  use fcFVFa0, only: formFVFa0
  use fcUSUa0, only: formUSUa0
  use fcVV0, only: formVV0
  use fcFFaV1, only: formFFaV1
  use fcFSFa1, only: formFSFa1
  use fcFaF2, only: formFaF2
  use fcFaSF2, only: formFaSF2
  use fcSVVS0, only: formSVVS0
  use fcVUUa0, only: formVUUa0
  use fcFaFS1, only: formFaFS1
  use fcVVVV1, only: formVVVV1
  use fcVSV0, only: formVSV0
  use fcSFFa1, only: formSFFa1
  use fcFFa1, only: formFFa1
  use fcSUaU0, only: formSUaU0
  use fcVVS0, only: formVVS0
  use fcVV4, only: formVV4
  use fcSSV0, only: formSSV0
  use fcSVV0, only: formSVV0
  use fcVSSV0, only: formVSSV0
  use fcVFaF0, only: formVFaF0
  use fcSFaF2, only: formSFaF2
  use fcSS0, only: formSS0
  use fcUUaV0, only: formUUaV0
  use fcVUaU0, only: formVUaU0
  use fcVVVV0, only: formVVVV0
  use fcVFFa1, only: formVFFa1
  use fcUVUa0, only: formUVUa0
  use fcFFa0, only: formFFa0
  use fcVSVS0, only: formVSVS0
  use fcFaVF1, only: formFaVF1
  use fcSFFa0, only: formSFFa0
  use fcSFFa2, only: formSFFa2
  use fcSV0, only: formSV0
  use fcSSSS0, only: formSSSS0
  use fcFSFa2, only: formFSFa2
  use fcUUaS0, only: formUUaS0
  use fcVVV0, only: formVVV0
  use fcFFa3, only: formFFa3
  use fcSUUa0, only: formSUUa0
  use fcVV3, only: formVV3
  use fcVFFa0, only: formVFFa0
  use fcFaF1, only: formFaF1
  use fcFaVF0, only: formFaVF0
  use fcFaSF1, only: formFaSF1
  use fcFaFV1, only: formFaFV1
  use fcVFaF1, only: formVFaF1
  use fcUaUV0, only: formUaUV0
  use fcFaFS2, only: formFaFS2
  use fcFSFa0, only: formFSFa0
  use fcFFaS0, only: formFFaS0
  use fcVS0, only: formVS0
  use fcSSS0, only: formSSS0
  implicit none

  contains

  subroutine form_current_mdl(lp, t, legs, j, nMax, e, f, w, cs, absolute_order&
  , ty, order_increase, sign, cou, colT_imag, colT_symbol, Nc_power,           &
  branch_type, branch)
    integer, intent(in) :: lp, t, legs, j, nMax, e(:), f(:), w(:), cs, ty, sign&
                           , Nc_power, branch_type, branch
    character(len=20), intent(in) :: colT_symbol
    logical, intent(in) :: cou(:), colT_imag
    integer, dimension(:), intent(in) :: order_increase, absolute_order
      integer :: legsE, i, ind, pext, mass_id, reg_id
      logical :: last = .false.
      character :: C2*5,C3*7,C4*9
      character(len=5) :: amp
      integer, parameter :: nDef = max_leg_multiplicity
      character(len=8) :: clegs, cj, cw(1:nDef), clast, ce(1:nDef)
      character(len=10) :: p(1:nDef)
      character(len=2) :: ct, cf(1:nDef)
      character(len=5) :: m(1:nDef)
      character(len=10) :: tag
      character(len=5) :: mgsb  ! Goldstone boson mass
      character(len=7) :: rxip  ! 1 - xi:  one minus rxi gauge parameter
      character(len=80) :: cgs
      character(len=80) :: amporder
      character(len=3) :: colorflow
      character(len=3) :: int_str
      character(len=80) :: cwp(1:nDef), den, den0, denGSB, cwIn, indent=''
      character(len=2*nMax+1) :: C

    if (lp.eq.1) then; legsE = legs + 2
    else;              legsE = legs
    endif
    last = e(nDef).eq.2**(legsE-1)-1
    write(clegs,'(i8)') legs; clegs = adjustl(clegs)
    ! changed j to j+2 which fixed a bug for 1 -> 1 tree-level diagrams
    write(cj,'(i8)') j+2; cj = adjustl(cj)
    
    do i = 1, nDef
      write(cw(i),'(i8)') w(i); cw(i) = adjustl(cw(i))
      cwp(i) = 'wp'//cw(i)
      write(ce(i),'(i8)') e(i); ce(i) = adjustl(ce(i))
      p(i) = 'p'//ce(i)
      write(cf(i),'(i2)') f(i)
      if (f(i).lt.10) cf(i) = '0' // trim(adjustl(cf(i)))
      ! f(i) may be zero, meaning that there is no particle at
      ! position i.
      if (f(i) .gt. 0) then
        mass_id = get_particle_mass_id_mdl(f(i))
        reg_id  = get_particle_mass_reg_mdl(f(i))
        if ((mass_id .eq. 1) .or. (reg_id .eq. 1) .or. &
            (reg_id .eq. 2 .and. masscut_frm)) then
          m(i) = 'M0'
        else
          if (complex_mass_frm .eqv. .true.) then
            m(i) = 'c'// get_mass_name_mdl(mass_id)
          else
            m(i) = get_mass_name_mdl(mass_id)
          end if
        end if
      end if
    end do
    
    ! Rxi propagator extension. Setting the goldstone boson
    ! propagator mass and gauge parameter
    
    pext = get_propagator_extension_mdl(ty)
    if (pext .gt. 0) then
      ! Z boson field
      if (f(nDef) .eq. get_particle_id_mdl('Z')) then
        mgsb = 'MG0'
        rxip = '(1-xiz)'
      ! Z quantum field
      else if (f(nDef) .eq. get_particle_id_mdl('ZQ')) then
        mgsb = 'MG0'
        rxip = '(1-xiQ)'
      ! W boson field
      else if (f(nDef) .eq. get_particle_id_mdl('W+') .or. &
              f(nDef) .eq. get_particle_id_mdl('W-')) then
        mgsb = 'MGP'
        rxip = '(1-xiw)'
      ! W quantum field
      else if (f(nDef) .eq. get_particle_id_mdl('WQ+') .or. &
              f(nDef) .eq. get_particle_id_mdl('WQ-')) then
        mgsb = 'MGP'
        rxip = '(1-xiQ)'
      ! Photon field
      else if (f(nDef) .eq. get_particle_id_mdl('a')) then
        mgsb = 'M0'
        rxip = '(1-xia)'
      ! Photon quantum field
      else if (f(nDef) .eq. get_particle_id_mdl('aQ')) then
        mgsb = 'M0'
        rxip = '(1-xiQ)'
      else
        write (*, *) 'Propagator extension for particle id ', &
                    f(nDef), ' not defined.'
        stop
      end if
    else
      mgsb = ''
      rxip = ''
    end if
    
    ! The couplings are specified by 3 + perturbative couplings(QED, QCD,..)
    ! arguments.
    ! The first argument indentifies the lorentz structure associated to a
    ! branch id.
    ! The following arguments are stored in cgs, the previous argument is
    ! determined after the lorentz structure selection (select(ty))
    ! The following indices are powers in perturbative couplings defined in
    ! class_particle.f90 order_ids.
    ! The next argument is the branch_type either tree(0), loop(1),
    ! ct(2) or r2(3)
    ! And the last index is the branch id associated to a particle combination
    
    ! powers in couplings
    write(cgs,'(i1)') order_increase(1)
    amporder = trim(cgs)
    do i = 2, size(order_increase)
      write(cgs,'(i1)') order_increase(i)
      amporder = trim(amporder)//','//trim(cgs)
    end do
    
    ! branch_type
    write(int_str,'(i1)') branch_type
    tag = trim(int_str)//','
    
    ! modelfile branch
    if (branch .lt. 10) then
      write(int_str,'(i1)') branch
    else if (branch .gt. 9 .and. branch .lt. 100) then
      write(int_str,'(i2)') branch
    else
      call error_mdl("More than 99 branches not supported.", &
                    where="form_current_mdl")
    end if
    tag = trim(tag)//trim(int_str)
    cgs = trim(amporder)//','//trim(tag)
    
    if (last) then
    if (lp .eq. 0) then
      amp = 'AmpLO'
    else if (lp .eq. 1) then
      write(ct,'(i2)') t
      if (t .lt. 10) ct = '0'//trim(adjustl(ct))
      amp = 'Amp'//trim(ct)
    else if (lp .eq. 2) then
      amp = 'AmpCT'
    else if (lp .eq. 3) then
      amp = 'AmpR2'
    end if
    write(colorflow,'(i3)') cs; colorflow = adjustl(colorflow)
    
    write(int_str,'(i1)') absolute_order(1)
    amporder = trim(order_ids(1))//'='//trim(int_str)
    do i = 2, size(order_increase)
      write(int_str,'(i1)') absolute_order(i)
      amporder = trim(amporder)//','//trim(order_ids(i))//'='//trim(int_str)
    end do
    cwp(nDef) = '['//amp//'(cs='//trim(colorflow)//','//trim(amporder)//')]'
    end if
    
    den  = 'den('//trim(p(nDef))//','//trim(m(nDef))//')'
    den0 = 'den('//trim(p(nDef))//',M0)'
    denGSB = 'den('//trim(p(nDef))//','//trim(mgsb)//')'
    ind = len(trim(cwp(nDef))) + 5
    write(999,'(a)')
    write(999,'(3a)') 'l ',trim(cwp(nDef)),' = '
    C = 'c'
    cwIn = '+'
    
    do i = 1, nMax -1
      C = trim(C)//cf(i)
      if(i .eq. 2) then; C3 = trim(C)//cf(nDef)
      else if (i.eq.3) then; C4 = trim(C)//cf(nDef)
      end if
      cwIn = trim(cwIn)//' '//trim(cwp(i))//' *'
    end do
    
    C = trim(C)//cf(nDef)
    write(999,'(a)') '  '//trim(cwp(nDef))//' '//trim(cwIn)
    
    if (last) then
      write(clast,'(i8)') legsE; clast = adjustl(clast)
      select case(get_particle_spin_mdl(f(nDef)))
      case(3)
        write(999,'(a)') indent(1:ind) // 'd_(mu' // trim(clast) // ',mu' // &
        trim(cw(nDef)) // ') * '
      case(2)
        write(999,'(a)') indent(1:ind) // 'd_(i' // trim(clast) // ',i' //   &
        trim(cw(nDef)) // ') * '
      end select
    end if
    
    write(999,'(a,i2,a)') indent(1:ind) // '(',sign,') * '
    
    if (Nc_power .ne. 0) then
      write(999,'(a, i3, a)') indent(1:ind) // 'Nc ** (',Nc_power,') * '
    end if
    write(999,'(a)') indent(1:ind) // trim(adjustl(colT_symbol)) // ' * '

    select case(ty)
    case(FFa2)
      call formFFa2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(SSVV0)
      call formSSVV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VV2)
      call formVV2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(SS2)
      call formSS2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(FaFV0)
      call formFaFV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VS1)
      call formVS1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(FaF0)
      call formFaF0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(UaUS0)
      call formUaUS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaSF0)
      call formFaSF0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FVFa1)
      call formFVFa1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VSS0)
      call formVSS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(UaVU0)
      call formUaVU0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SVS0)
      call formSVS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(FFaS1)
      call formFFaS1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SFaF0)
      call formSFaF0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SFaF1)
      call formSFaF1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SV1)
      call formSV1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(UaSU0)
      call formUaSU0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VVSS0)
      call formVVSS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaFS0)
      call formFaFS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VV1)
      call formVV1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(FFaS2)
      call formFFaS2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SVSV0)
      call formSVSV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaF3)
      call formFaF3(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(FFaV0)
      call formFFaV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SS1)
      call formSS1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(FVFa0)
      call formFVFa0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(USUa0)
      call formUSUa0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VV0)
      call formVV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(FFaV1)
      call formFFaV1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FSFa1)
      call formFSFa1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaF2)
      call formFaF2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(FaSF2)
      call formFaSF2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SVVS0)
      call formSVVS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VUUa0)
      call formVUUa0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaFS1)
      call formFaFS1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VVVV1)
      call formVVVV1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VSV0)
      call formVSV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(SFFa1)
      call formSFFa1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FFa1)
      call formFFa1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(SUaU0)
      call formSUaU0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VVS0)
      call formVVS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(VV4)
      call formVV4(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(SSV0)
      call formSSV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(SVV0)
      call formSVV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(VSSV0)
      call formVSSV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VFaF0)
      call formVFaF0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SFaF2)
      call formSFaF2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SS0)
      call formSS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(UUaV0)
      call formUUaV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VUaU0)
      call formVUaU0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VVVV0)
      call formVVVV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VFFa1)
      call formVFFa1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(UVUa0)
      call formUVUa0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FFa0)
      call formFFa0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(VSVS0)
      call formVSVS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaVF1)
      call formFaVF1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SFFa0)
      call formSFFa0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SFFa2)
      call formSFFa2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(SV0)
      call formSV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(SSSS0)
      call formSSSS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FSFa2)
      call formFSFa2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(UUaS0)
      call formUUaS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VVV0)
      call formVVV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(FFa3)
      call formFFa3(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(SUUa0)
      call formSUUa0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VV3)
      call formVV3(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(VFFa0)
      call formVFFa0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaF1)
      call formFaF1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case(FaVF0)
      call formFaVF0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaSF1)
      call formFaSF1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaFV1)
      call formFaFV1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VFaF1)
      call formVFaF1(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(UaUV0)
      call formUaUV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FaFS2)
      call formFaFS2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FSFa0)
      call formFSFa0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(FFaS0)
      call formFFaS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
      , cw, cj, C, m, p)
    case(VS0)
      call formVS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs,  &
      cw, cj, C, m, p)
    case(SSS0)
      call formSSS0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs, &
      cw, cj, C, m, p)
    case default
      write(int_str,'(i3)') ty
      call error_mdl('Unhandled case: ' // int_str, where='form_current_mdl')
    end select 
  end subroutine form_current_mdl
end module class_form
