!******************************************************************************!
!                                                                              !
!    fill_ctcouplings2.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings2.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  contains
    subroutine fill_CTcouplings_mdl2()
      coupl(nGC_3131) = (-10d0*cima*coupl(nGC_10)**4d0*sq2**4d0 + 6d0*cima*    &
                        coupl(nGC_1113)**2d0 + 3d0*coupl(nGC_10)**2d0*coupl(   &
                        nGC_1107)*sq2**2d0 + 18d0*coupl(nGC_10)**2d0*coupl(    &
                        nGC_1113)*sq2**2d0)/(192d0*pi**2d0)
      coupl(nGC_3130) = (-10d0*cima*coupl(nGC_10)**4d0*sq2**4d0 + 6d0*cima*    &
                        coupl(nGC_1113)**2d0 + 3d0*coupl(nGC_10)**2d0*coupl(   &
                        nGC_1111)*sq2**2d0 + 15d0*coupl(nGC_10)**2d0*coupl(    &
                        nGC_1113)*sq2**2d0 + 3d0*coupl(nGC_10)**2d0*coupl(     &
                        nGC_12)*sq2**2d0)/(192d0*pi**2d0)
      coupl(nGC_3137) = (-4d0*Nc*cima*coupl(nGC_10)**4d0*sq2**4d0 - 12d0*Nc*   &
                        cima*coupl(nGC_1111)*coupl(nGC_12) - 12d0*Nc*coupl(    &
                        nGC_10)**2d0*coupl(nGC_1111)*sq2**2d0 + 9d0*Nc*coupl(  &
                        nGC_10)**2d0*coupl(nGC_12)*sq2**2d0 + 15d0*cima*coupl( &
                        nGC_11)**4d0*sq2**4d0)/(384d0*pi**2d0)
      coupl(nGC_3136) = (-8d0*Nc*cima*coupl(nGC_10)**4d0*sq2**4d0 - 24d0*Nc*   &
                        cima*coupl(nGC_1111)*coupl(nGC_12) - 39d0*Nc*coupl(    &
                        nGC_10)**2d0*coupl(nGC_1111)*sq2**2d0 + 3d0*Nc*coupl(  &
                        nGC_10)**2d0*coupl(nGC_12)*sq2**2d0 + 30d0*cima*coupl( &
                        nGC_11)**4d0*sq2**4d0)/(768d0*pi**2d0)
      coupl(nGC_3135) = sq2**2d0*(-4d0*Nc*cima*coupl(nGC_10)**4d0*sq2**2d0 +   &
                        3d0*Nc*coupl(nGC_10)**2d0*coupl(nGC_1107) - 9d0*Nc*    &
                        coupl(nGC_10)**2d0*coupl(nGC_1113) - 50d0*cima*coupl(  &
                        nGC_11)**4d0*sq2**2d0)/(768d0*pi**2d0)
      coupl(nGC_3134) = sq2**2d0*(-4d0*Nc*cima*coupl(nGC_10)**4d0*sq2**2d0 +   &
                        9d0*Nc*coupl(nGC_10)**2d0*coupl(nGC_1107) - 3d0*Nc*    &
                        coupl(nGC_10)**2d0*coupl(nGC_1113) - 50d0*cima*coupl(  &
                        nGC_11)**4d0*sq2**2d0)/(768d0*pi**2d0)
      coupl(nGC_5000) = coupl(nGC_2)*dZA/2d0 + coupl(nGC_3279) + coupl(nGC_39)*&
                        dZZA/2d0
      coupl(nGC_4639) = coupl(nGC_34)*dZbR_QED2
      coupl(nGC_4635) = coupl(nGC_38)*dZbL_QED2
      coupl(nGC_4636) = coupl(nGC_38)*dZbL_QCD2
      coupl(nGC_4631) = coupl(nGC_MI)*dZnu_tauL
      coupl(nGC_4630) = coupl(nGC_3373) + coupl(nGC_81)*dZnu_tauL/2d0 + coupl( &
                        nGC_81)*dZtauMinusR/2d0
      coupl(nGC_4632) = coupl(nGC_MI)*dZnu_tauR
      coupl(nGC_TS_GC_15_H) = -coupl(nGC_15)*dt/cMH**2d0
      coupl(nGC_5946) = coupl(nGC_25)*dZZA/2d0 + coupl(nGC_3)*dZA/2d0 + coupl( &
                        nGC_3)*dZWMinus + coupl(nGC_3145)
      coupl(nGC_3047) = cMM*cima*(-coupl(nGC_36)*coupl(nGC_40) - coupl(nGC_4)**&
                        2d0)/(8d0*pi**2d0)
      coupl(nGC_3046) = cima*(-coupl(nGC_36)**2d0 - coupl(nGC_4)**2d0)/(16d0*pi&
                        **2d0)
      coupl(nGC_3045) = cME*cima*(-coupl(nGC_36)*coupl(nGC_40) - coupl(nGC_4)**&
                        2d0)/(8d0*pi**2d0)
      coupl(nGC_3044) = cima*(-coupl(nGC_23)**2d0 - coupl(nGC_4)**2d0 - coupl( &
                        nGC_40)**2d0)/(16d0*pi**2d0)
      coupl(nGC_3043) = cima*(-coupl(nGC_23)**2d0 - coupl(nGC_41)**2d0)/(16d0* &
                        pi**2d0)
      coupl(nGC_5341) = -coupl(nGC_10)*dZg_QCD2/2d0 - coupl(nGC_3141)
      coupl(nGC_4794) = coupl(nGC_26)*dZA/2d0 + coupl(nGC_26)*dZWMinus/2d0 +   &
                        coupl(nGC_3229) + coupl(nGC_7)*dZZA/2d0
      coupl(nGC_3049) = cMU*cima*coupl(nGC_11)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_3048) = cMTA*cima*(-coupl(nGC_36)*coupl(nGC_40) - coupl(nGC_4  &
                        )**2d0)/(8d0*pi**2d0)
      coupl(nGC_7203) = -coupl(nGC_37)*dZZA/2d0
      coupl(nGC_3268) = coupl(nGC_3265)*dZee + coupl(nGC_3266)*dsw_ + coupl(   &
                        nGC_3267)*dcw_
      coupl(nGC_4844) = coupl(nGC_26)*dZAZ/2d0 + coupl(nGC_3264) + coupl(nGC_7 &
                        )*dZWMinus/2d0 + coupl(nGC_7)*dZZ/2d0
      coupl(nGC_3050) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(64d0&
                        *pi**2d0*Nc)
      coupl(nGC_TS_GC_17_H) = -coupl(nGC_17)*dt/cMH**2d0
      coupl(nGC_3051) = cima*(-coupl(nGC_2)**2d0 - coupl(nGC_23)**2d0 - coupl( &
                        nGC_39)**2d0)/(16d0*pi**2d0)
      coupl(nGC_3348) = coupl(nGC_3346)*dyb_QED2
      coupl(nGC_3349) = coupl(nGC_3346)*dyb_QED1_QCD2
      coupl(nGC_3344) = coupl(nGC_3341)*dys_QED1_QCD2
      coupl(nGC_3345) = coupl(nGC_3341)*dys_QED1
      coupl(nGC_3340) = coupl(nGC_3336)*dys_QED1
      coupl(nGC_5400) = coupl(nGC_3251) + coupl(nGC_4)*dZAZ/2d0 + coupl(nGC_40 &
                        )*dZZ/2d0 + coupl(nGC_40)*dZtauMinusL
      coupl(nGC_4836) = coupl(nGC_3400) + coupl(nGC_88)*dZuL_QCD2/2d0 + coupl( &
                        nGC_88)*dZuR_QCD2/2d0
      coupl(nGC_4835) = coupl(nGC_3395) + coupl(nGC_86)*dZuL_QCD2/2d0 + coupl( &
                        nGC_86)*dZuR_QCD2/2d0
      coupl(nGC_4834) = coupl(nGC_3398) + coupl(nGC_88)*dZuL_QED2/2d0 + coupl( &
                        nGC_88)*dZuR_QED2/2d0
      coupl(nGC_3469) = coupl(nGC_197)*dMZ2
      coupl(nGC_3468) = coupl(nGC_193)*dMW2
      coupl(nGC_3467) = coupl(nGC_189)*dMW2
      coupl(nGC_8211) = coupl(nGC_I)*dZH
      coupl(nGC_TS_GC_55_H) = -coupl(nGC_55)*dt/cMH**2d0
      coupl(nGC_5043) = coupl(nGC_20)*dZH/2d0 + coupl(nGC_20)*dZWMinus/2d0 +   &
                        coupl(nGC_3232)
      coupl(nGC_3188) = coupl(nGC_3185)*dsw_ + coupl(nGC_3186)*dMW2 + coupl(   &
                        nGC_3187)*dZee
      coupl(nGC_5712) = coupl(nGC_3305) + coupl(nGC_41)*dZZ/2d0 + coupl(nGC_41 &
                        )*dZnu_eL
      coupl(nGC_3180) = coupl(nGC_3176)*dsw_ + coupl(nGC_3177)*dMW2 + coupl(   &
                        nGC_3178)*dZee + coupl(nGC_3179)*dcw_
      coupl(nGC_5653) = coupl(nGC_34)*dZsR_QED2
      coupl(nGC_5654) = coupl(nGC_34)*dZsR_QCD2
      coupl(nGC_3032) = -Nc*cima*coupl(nGC_10)**2d0*sq2**2d0/(96d0*pi**2d0)
      coupl(nGC_3033) = cima*coupl(nGC_11)**2d0*sq2**2d0*(cMB**2d0 + cMC**2d0  &
                         + cMD**2d0 + cMS**2d0 + cMU**2d0)/(16d0*pi**2d0)
      coupl(nGC_3164) = coupl(nGC_3163)*dZee
      coupl(nGC_4698) = coupl(nGC_3371) + coupl(nGC_65)*dZeMinusR/2d0 + coupl( &
                        nGC_65)*dZnu_eL/2d0
      coupl(nGC_3162) = coupl(nGC_3159)*dZee + coupl(nGC_3160)*dsw_ + coupl(   &
                        nGC_3161)*dcw_
      coupl(nGC_9531) = -coupl(nGC_3087)
      coupl(nGC_9533) = -coupl(nGC_3088)
      coupl(nGC_7488) = coupl(nGC_MI)*dZbR_QED2
      coupl(nGC_7484) = coupl(nGC_MI)*dZbL_QED2
      coupl(nGC_TS_GC_75_H) = -coupl(nGC_75)*dt/cMH**2d0
      coupl(nGC_7680) = coupl(nGC_3458) + coupl(nGC_MD)*dZdL_QCD2/2d0 + coupl( &
                        nGC_MD)*dZdR_QCD2/2d0
      coupl(nGC_4889) = coupl(nGC_3387) + coupl(nGC_67)*dZH/2d0 + coupl(nGC_67 &
                        )*dZeMinusL/2d0 + coupl(nGC_67)*dZeMinusR/2d0
      coupl(nGC_5374) = coupl(nGC_41)*dZZA/2d0
      coupl(nGC_5902) = coupl(nGC_MI)*dZcR_QED2
      coupl(nGC_5903) = coupl(nGC_MI)*dZcR_QCD2
      coupl(nGC_5904) = coupl(nGC_3452) + coupl(nGC_MC)*dZcL_QED2/2d0 + coupl( &
                        nGC_MC)*dZcR_QED2/2d0
      coupl(nGC_5905) = coupl(nGC_3453) + coupl(nGC_TS_GC_59_H)
      coupl(nGC_5906) = coupl(nGC_3454) + coupl(nGC_MC)*dZcL_QCD2/2d0 + coupl( &
                        nGC_MC)*dZcR_QCD2/2d0
      coupl(nGC_3133) = (-8d0*Nc*cima*coupl(nGC_10)**4d0*sq2**4d0 + 12d0*Nc*   &
                        cima*coupl(nGC_1111)**2d0 + 12d0*Nc*cima*coupl(nGC_12  &
                        )**2d0 - 3d0*Nc*coupl(nGC_10)**2d0*coupl(nGC_1111)*sq2 &
                        **2d0 + 39d0*Nc*coupl(nGC_10)**2d0*coupl(nGC_12)*sq2** &
                        2d0 + 30d0*cima*coupl(nGC_11)**4d0*sq2**4d0)/(768d0*pi &
                        **2d0)
      coupl(nGC_3132) = (-4d0*Nc*cima*coupl(nGC_10)**4d0*sq2**4d0 - 12d0*Nc*   &
                        cima*coupl(nGC_1111)*coupl(nGC_12) - 9d0*Nc*coupl(     &
                        nGC_10)**2d0*coupl(nGC_1111)*sq2**2d0 + 12d0*Nc*coupl( &
                        nGC_10)**2d0*coupl(nGC_12)*sq2**2d0 + 15d0*cima*coupl( &
                        nGC_11)**4d0*sq2**4d0)/(384d0*pi**2d0)
      coupl(nGC_6651) = coupl(nGC_3465) + coupl(nGC_MZ)*dZZ
      coupl(nGC_7489) = coupl(nGC_MI)*dZbR_QCD2
      coupl(nGC_TS_GC_37_H) = -coupl(nGC_37)*dt/cMH**2d0
      coupl(nGC_4871) = coupl(nGC_3220) + coupl(nGC_47)*dZZA/2d0 + coupl(nGC_51&
                        )*dZA/2d0 + coupl(nGC_51)*dZWMinus/2d0
      coupl(nGC_5286) = coupl(nGC_3164) + coupl(nGC_4)*dZA/2d0 + coupl(nGC_4)* &
                        dZmuMinusL + coupl(nGC_40)*dZZA/2d0
      coupl(nGC_5285) = coupl(nGC_3164) + coupl(nGC_36)*dZZA/2d0 + coupl(nGC_4 &
                        )*dZA/2d0 + coupl(nGC_4)*dZmuMinusR
      coupl(nGC_3109) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_55)**2d0  &
                         - coupl(nGC_59)**2d0 - coupl(nGC_63)**2d0 - coupl(    &
                        nGC_75)**2d0 - coupl(nGC_87)**2d0)/(16d0*pi**2d0)
      coupl(nGC_3239) = coupl(nGC_3236)*dsw_ + coupl(nGC_3237)*dZee + coupl(   &
                        nGC_3238)*dvev_QEDM1
      coupl(nGC_3235) = coupl(nGC_3233)*dZee + coupl(nGC_3234)*dsw_
      coupl(nGC_5122) = coupl(nGC_11)*dZsL_QED2
      coupl(nGC_5126) = coupl(nGC_11)*dZsR_QED2
      coupl(nGC_6005) = coupl(nGC_11)*dZdR_QED2
      coupl(nGC_3301) = coupl(nGC_3298)*dZee + coupl(nGC_3299)*dsw_ + coupl(   &
                        nGC_3300)*dcw_
      coupl(nGC_7485) = coupl(nGC_MI)*dZbL_QCD2
      coupl(nGC_5459) = coupl(nGC_2)*dZcR_QED2
      coupl(nGC_4909) = coupl(nGC_3312) + coupl(nGC_61)*dZdR_QCD2/2d0 + coupl( &
                        nGC_61)*dZuL_QCD2/2d0
      coupl(nGC_4908) = coupl(nGC_3314) + coupl(nGC_85)*dZdL_QED2/2d0 + coupl( &
                        nGC_85)*dZuR_QED2/2d0
      coupl(nGC_3281) = coupl(nGC_3280)*dZee
      coupl(nGC_3129) = (-5d0*cima*coupl(nGC_10)**4d0*sq2**4d0 + 3d0*cima*coupl&
                        (nGC_1111)**2d0 - 6d0*cima*coupl(nGC_1111)*coupl(nGC_12&
                        ) + 3d0*cima*coupl(nGC_12)**2d0 - 6d0*coupl(nGC_10)**  &
                        2d0*coupl(nGC_1111)*sq2**2d0 + 9d0*coupl(nGC_10)**2d0* &
                        coupl(nGC_12)*sq2**2d0)/(96d0*pi**2d0)
      coupl(nGC_3282) = coupl(nGC_127)*dZgs_QCD2
      coupl(nGC_3285) = coupl(nGC_3283)*dZee + coupl(nGC_3284)*dsw_
      coupl(nGC_7321) = coupl(nGC_21)*dZH/2d0 + coupl(nGC_21)*dZWMinus/2d0 +   &
                        coupl(nGC_3226)
      coupl(nGC_3289) = coupl(nGC_3286)*dZee + coupl(nGC_3287)*dsw_ + coupl(   &
                        nGC_3288)*dcw_
      coupl(nGC_3122) = 3d0*cima*coupl(nGC_11)**3d0*sq2**3d0*(-3d0*coupl(nGC_34&
                        ) - 2d0*coupl(nGC_35) + 3d0*coupl(nGC_38) + 2d0*coupl( &
                        nGC_39))/(128d0*pi**2d0)
      coupl(nGC_3123) = sq2**2d0*(-2d0*Nc*cima*coupl(nGC_10)**4d0*sq2**2d0 +   &
                        3d0*Nc*coupl(nGC_10)**2d0*coupl(nGC_1107) - 3d0*Nc*    &
                        coupl(nGC_10)**2d0*coupl(nGC_1113) - 25d0*cima*coupl(  &
                        nGC_11)**4d0*sq2**2d0)/(384d0*pi**2d0)
      coupl(nGC_3124) = (-8d0*Nc*cima*coupl(nGC_10)**4d0*sq2**4d0 + 12d0*Nc*   &
                        cima*coupl(nGC_1111)**2d0 + 12d0*Nc*cima*coupl(nGC_12  &
                        )**2d0 - 21d0*Nc*coupl(nGC_10)**2d0*coupl(nGC_1111)*sq2&
                        **2d0 + 21d0*Nc*coupl(nGC_10)**2d0*coupl(nGC_12)*sq2** &
                        2d0 + 30d0*cima*coupl(nGC_11)**4d0*sq2**4d0)/(768d0*pi &
                        **2d0)
      coupl(nGC_3125) = (20d0*Nc*cima*coupl(nGC_10)**4d0*sq2**4d0 + 12d0*Nc*   &
                        cima*coupl(nGC_1111)*coupl(nGC_1113) - 12d0*Nc*cima*   &
                        coupl(nGC_1113)*coupl(nGC_12) - 3d0*Nc*coupl(nGC_10)** &
                        2d0*coupl(nGC_1107)*sq2**2d0 + 15d0*Nc*coupl(nGC_10)** &
                        2d0*coupl(nGC_1111)*sq2**2d0 - 15d0*Nc*coupl(nGC_10)** &
                        2d0*coupl(nGC_1113)*sq2**2d0 - 21d0*Nc*coupl(nGC_10)** &
                        2d0*coupl(nGC_12)*sq2**2d0 - 10d0*cima*coupl(nGC_11)** &
                        4d0*sq2**4d0)/(768d0*pi**2d0*Nc)
      coupl(nGC_3126) = (10d0*Nc*cima*coupl(nGC_10)**4d0*sq2**4d0 + 6d0*Nc*cima&
                        *coupl(nGC_1111)*coupl(nGC_1113) - 6d0*Nc*cima*coupl(  &
                        nGC_1113)*coupl(nGC_12) + 6d0*Nc*coupl(nGC_10)**2d0*   &
                        coupl(nGC_1111)*sq2**2d0 - 6d0*Nc*coupl(nGC_10)**2d0*  &
                        coupl(nGC_1113)*sq2**2d0 - 12d0*Nc*coupl(nGC_10)**2d0* &
                        coupl(nGC_12)*sq2**2d0 - 5d0*cima*coupl(nGC_11)**4d0*  &
                        sq2**4d0)/(384d0*pi**2d0*Nc)
      coupl(nGC_3127) = (10d0*Nc*cima*coupl(nGC_10)**4d0*sq2**4d0 + 6d0*Nc*cima&
                        *coupl(nGC_1111)*coupl(nGC_1113) - 6d0*Nc*cima*coupl(  &
                        nGC_1113)*coupl(nGC_12) - 3d0*Nc*coupl(nGC_10)**2d0*   &
                        coupl(nGC_1107)*sq2**2d0 + 9d0*Nc*coupl(nGC_10)**2d0*  &
                        coupl(nGC_1111)*sq2**2d0 - 9d0*Nc*coupl(nGC_10)**2d0*  &
                        coupl(nGC_1113)*sq2**2d0 - 9d0*Nc*coupl(nGC_10)**2d0*  &
                        coupl(nGC_12)*sq2**2d0 - 5d0*cima*coupl(nGC_11)**4d0*  &
                        sq2**4d0)/(384d0*pi**2d0*Nc)
      coupl(nGC_5018) = -coupl(nGC_25)*dZZA/2d0 - coupl(nGC_3)*dZA/2d0 - coupl(&
                        nGC_3)*dZWMinus - coupl(nGC_3145)
      coupl(nGC_5621) = coupl(nGC_11)*dZuR_QED2
      coupl(nGC_5623) = coupl(nGC_11)*dZuL_QED2
      coupl(nGC_5625) = coupl(nGC_11)*dZg_QCD2/2d0 + coupl(nGC_11)*dZuR_QCD2 + &
                        coupl(nGC_3282)
      coupl(nGC_5626) = coupl(nGC_11)*dZg_QCD2/2d0 + coupl(nGC_11)*dZuL_QCD2 + &
                        coupl(nGC_3282)
      coupl(nGC_5971) = coupl(nGC_3451) + coupl(nGC_MU)*dZuL_QCD2/2d0 + coupl( &
                        nGC_MU)*dZuR_QCD2/2d0
      coupl(nGC_5970) = coupl(nGC_3450) + coupl(nGC_TS_GC_87_H)
      coupl(nGC_3054) = cMC*cima*coupl(nGC_11)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_3055) = cMC*cima*(-coupl(nGC_2)**2d0 - coupl(nGC_35)*coupl(    &
                        nGC_39))/(8d0*pi**2d0)
      coupl(nGC_3056) = cMD*cima*coupl(nGC_11)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(&
                        32d0*pi**2d0*Nc)
      coupl(nGC_3057) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_23)**2d0 - coupl( &
                        nGC_38)**2d0)/(16d0*pi**2d0)
      coupl(nGC_5337) = -coupl(nGC_MI)*dZg_QCD2
      coupl(nGC_5336) = coupl(nGC_MI)*dZg_QCD2
      coupl(nGC_3052) = cMU*cima*(-coupl(nGC_2)**2d0 - coupl(nGC_35)*coupl(    &
                        nGC_39))/(8d0*pi**2d0)
      coupl(nGC_3053) = cima*(-coupl(nGC_2)**2d0 - coupl(nGC_35)**2d0)/(16d0*pi&
                        **2d0)
      coupl(nGC_3058) = cMD*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_34)*coupl(    &
                        nGC_38))/(8d0*pi**2d0)
      coupl(nGC_3059) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_34)**2d0)/(16d0*pi&
                        **2d0)
      coupl(nGC_5176) = coupl(nGC_3164) + coupl(nGC_4)*dZA/2d0 + coupl(nGC_4)* &
                        dZtauMinusL + coupl(nGC_40)*dZZA/2d0
      coupl(nGC_6343) = coupl(nGC_37)*dZZA/2d0
      coupl(nGC_5097) = coupl(nGC_3322) + coupl(nGC_73)*dZcL_QED2/2d0 + coupl( &
                        nGC_73)*dZsR_QED2/2d0
      coupl(nGC_6617) = coupl(nGC_3421) + coupl(nGC_59)*dZH/2d0
      coupl(nGC_6616) = coupl(nGC_3420) + coupl(nGC_59)*dZcL_QCD2/2d0 + coupl( &
                        nGC_59)*dZcR_QCD2/2d0
      coupl(nGC_3379) = coupl(nGC_3378)*dym_QED1
      coupl(nGC_3370) = coupl(nGC_3366)*dyb_QED1
      coupl(nGC_3375) = coupl(nGC_3374)*dye_QED1
      coupl(nGC_3377) = coupl(nGC_3376)*dye_QED1
      coupl(nGC_5416) = coupl(nGC_3342) + coupl(nGC_76)*dZsL_QED2/2d0 + coupl( &
                        nGC_76)*dZsR_QED2/2d0
      coupl(nGC_5418) = coupl(nGC_3344) + coupl(nGC_76)*dZsL_QCD2/2d0 + coupl( &
                        nGC_76)*dZsR_QCD2/2d0
      coupl(nGC_4944) = coupl(nGC_23)*dZWMinus/2d0 + coupl(nGC_3285)
      coupl(nGC_5050) = -coupl(nGC_25)*dZZA/2d0 - coupl(nGC_3)*dZA/2d0 - coupl(&
                        nGC_3145)
      coupl(nGC_5779) = coupl(nGC_35)*dZuR_QCD2
      coupl(nGC_3272) = coupl(nGC_3269)*dZee + coupl(nGC_3270)*dsw_ + coupl(   &
                        nGC_3271)*dcw_
      coupl(nGC_4729) = coupl(nGC_3369) + coupl(nGC_55)*dZbL_QCD2/2d0 + coupl( &
                        nGC_55)*dZbR_QCD2/2d0
      coupl(nGC_4728) = coupl(nGC_3370) + coupl(nGC_55)*dZH/2d0
      coupl(nGC_4727) = coupl(nGC_3367) + coupl(nGC_55)*dZbL_QED2/2d0 + coupl( &
                        nGC_55)*dZbR_QED2/2d0
      coupl(nGC_3151) = coupl(nGC_3148)*dZee + coupl(nGC_3149)*dsw_ + coupl(   &
                        nGC_3150)*dcw_
      coupl(nGC_3019) = cima*(-4d0*Nc*coupl(nGC_23)**2d0 - 6d0*coupl(nGC_23)** &
                        2d0 - 3d0*coupl(nGC_25)**2d0 - 3d0*coupl(nGC_3)**2d0 - &
                        3d0*coupl(nGC_313)**2d0 - 3d0*coupl(nGC_451)**2d0)/(   &
                        96d0*pi**2d0)
      coupl(nGC_3409) = coupl(nGC_3407)*dyc_QED2
      coupl(nGC_3408) = coupl(nGC_3407)*dyc_QED3
      coupl(nGC_3406) = coupl(nGC_3402)*dyc_QED1
      coupl(nGC_3405) = coupl(nGC_3402)*dyc_QED1_QCD2
      coupl(nGC_3404) = coupl(nGC_3402)*dyc_QED2
      coupl(nGC_3403) = coupl(nGC_3402)*dyc_QED3
      coupl(nGC_4686) = -4d0*coupl(nGC_18)*dZWMinus - 2d0*coupl(nGC_3154)
      coupl(nGC_4687) = 2d0*coupl(nGC_18)*dZWMinus + coupl(nGC_3154)
      coupl(nGC_3083) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_1)**2d0 - 4d0*coupl( &
                        nGC_23)**2d0 - 4d0*coupl(nGC_38)**2d0 - coupl(nGC_62)* &
                        coupl(nGC_64) - coupl(nGC_63)**2d0 - coupl(nGC_85)**2d0&
                        )/(64d0*pi**2d0*Nc)
      coupl(nGC_3082) = coupl(nGC_11)**2d0*sq2**2d0*(cMB*coupl(nGC_55) + cMC*  &
                        coupl(nGC_59) + cMD*coupl(nGC_63) + cMS*coupl(nGC_75   &
                        ) + cMU*coupl(nGC_87))/(16d0*pi**2d0*Nc)
      coupl(nGC_3081) = coupl(nGC_11)**2d0*sq2**2d0*(-cMB*coupl(nGC_55) - cMC* &
                        coupl(nGC_59) - cMD*coupl(nGC_63) - cMS*coupl(nGC_75   &
                        ) - cMU*coupl(nGC_87))/(16d0*pi**2d0)
      coupl(nGC_3080) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_2)**2d0 + 4d0*coupl(  &
                        nGC_35)**2d0 + coupl(nGC_57)**2d0 + coupl(nGC_58)*coupl&
                        (nGC_60) + coupl(nGC_59)**2d0)/(64d0*pi**2d0)
      coupl(nGC_3086) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_1)**2d0 + 4d0*coupl(  &
                        nGC_34)**2d0 + coupl(nGC_61)**2d0 + coupl(nGC_62)*coupl&
                        (nGC_64) + coupl(nGC_63)**2d0)/(64d0*pi**2d0)
      coupl(nGC_3085) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_1)**2d0 + 4d0*coupl(  &
                        nGC_23)**2d0 + 4d0*coupl(nGC_38)**2d0 + coupl(nGC_62)* &
                        coupl(nGC_64) + coupl(nGC_63)**2d0 + coupl(nGC_85)**2d0&
                        )/(64d0*pi**2d0)
      coupl(nGC_3084) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_1)**2d0 - 4d0*coupl( &
                        nGC_34)**2d0 - coupl(nGC_61)**2d0 - coupl(nGC_62)*coupl&
                        (nGC_64) - coupl(nGC_63)**2d0)/(64d0*pi**2d0*Nc)
      coupl(nGC_7491) = coupl(nGC_3463) + coupl(nGC_TS_GC_55_H)
      coupl(nGC_3021) = (2d0*Nc*cMC**2d0*cima*coupl(nGC_23)**2d0 + 2d0*Nc*cMD**&
                        2d0*cima*coupl(nGC_23)**2d0 + 2d0*Nc*cMS**2d0*cima*    &
                        coupl(nGC_23)**2d0 + 2d0*Nc*cMU**2d0*cima*coupl(nGC_23 &
                        )**2d0 + 2d0*cME**2d0*cima*coupl(nGC_23)**2d0 + 2d0*cMM&
                        **2d0*cima*coupl(nGC_23)**2d0 + 2d0*cMTA**2d0*cima*    &
                        coupl(nGC_23)**2d0 + 3d0*cMW**2d0*cima*coupl(nGC_25)** &
                        2d0 + 3d0*cMW**2d0*cima*coupl(nGC_3)**2d0 + 3d0*cMW**  &
                        2d0*cima*coupl(nGC_313)**2d0 + 3d0*cMW**2d0*cima*coupl(&
                        nGC_451)**2d0 - 4d0*cMW**2d0*coupl(nGC_18) + 3d0*cMZ** &
                        2d0*cima*coupl(nGC_25)**2d0 + 3d0*cMZ**2d0*cima*coupl( &
                        nGC_451)**2d0 - 2d0*cMZ**2d0*coupl(nGC_469))/(32d0*pi**&
                        2d0)
      coupl(nGC_3339) = coupl(nGC_3336)*dys_QED1_QCD2
      coupl(nGC_4981) = coupl(nGC_22)*dZWMinus/2d0 + coupl(nGC_3223)
      coupl(nGC_4863) = coupl(nGC_3327) + coupl(nGC_64)*dZdL_QED2/2d0 + coupl( &
                        nGC_64)*dZdR_QED2/2d0
      coupl(nGC_4864) = coupl(nGC_3332) + coupl(nGC_62)*dZdL_QED2/2d0 + coupl( &
                        nGC_62)*dZdR_QED2/2d0
      coupl(nGC_4866) = coupl(nGC_3334) + coupl(nGC_62)*dZdL_QCD2/2d0 + coupl( &
                        nGC_62)*dZdR_QCD2/2d0
      coupl(nGC_3208) = coupl(nGC_3206)*dlam_QED2 + coupl(nGC_3207)*dvev_QEDM1
      coupl(nGC_3201) = coupl(nGC_3200)*dlam_QED2
      coupl(nGC_3205) = coupl(nGC_3203)*dlam_QED2 + coupl(nGC_3204)*dvev_QEDM1
      coupl(nGC_5098) = coupl(nGC_3320) + coupl(nGC_57)*dZcR_QCD2/2d0 + coupl( &
                        nGC_57)*dZsL_QCD2/2d0
      coupl(nGC_5099) = coupl(nGC_3324) + coupl(nGC_73)*dZcL_QCD2/2d0 + coupl( &
                        nGC_73)*dZsR_QCD2/2d0
      coupl(nGC_4910) = coupl(nGC_3316) + coupl(nGC_85)*dZdL_QCD2/2d0 + coupl( &
                        nGC_85)*dZuR_QCD2/2d0
      coupl(nGC_3338) = coupl(nGC_3336)*dys_QED2
      coupl(nGC_5423) = coupl(nGC_25)*dZWMinus + coupl(nGC_25)*dZZ/2d0 + coupl(&
                        nGC_3)*dZAZ/2d0 + coupl(nGC_3151)
      coupl(nGC_3337) = coupl(nGC_3336)*dys_QED3
      coupl(nGC_5588) = coupl(nGC_3251) + coupl(nGC_4)*dZAZ/2d0 + coupl(nGC_40 &
                        )*dZZ/2d0
      coupl(nGC_3330) = coupl(nGC_3326)*dydo_QED1
      coupl(nGC_3115) = cima*coupl(nGC_11)**2d0*sq2**2d0*(coupl(nGC_57)**2d0 + &
                        coupl(nGC_61)**2d0 + coupl(nGC_73)**2d0 + coupl(nGC_85 &
                        )**2d0)/(32d0*pi**2d0*Nc)
      coupl(nGC_3114) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_57)**2d0  &
                         - coupl(nGC_61)**2d0 - coupl(nGC_73)**2d0 - coupl(    &
                        nGC_85)**2d0)/(32d0*pi**2d0)
      coupl(nGC_3117) = cima*coupl(nGC_11)**2d0*sq2**2d0*(coupl(nGC_54)*coupl( &
                        nGC_56) + coupl(nGC_58)*coupl(nGC_60) + coupl(nGC_62)* &
                        coupl(nGC_64) + coupl(nGC_74)*coupl(nGC_76) + coupl(   &
                        nGC_86)*coupl(nGC_88))/(16d0*pi**2d0*Nc)
      coupl(nGC_3116) = cima*coupl(nGC_11)**2d0*sq2**2d0*(-coupl(nGC_54)*coupl(&
                        nGC_56) - coupl(nGC_58)*coupl(nGC_60) - coupl(nGC_62)* &
                        coupl(nGC_64) - coupl(nGC_74)*coupl(nGC_76) - coupl(   &
                        nGC_86)*coupl(nGC_88))/(16d0*pi**2d0)
      coupl(nGC_3110) = cima*coupl(nGC_11)**2d0*sq2**2d0*(coupl(nGC_55)**2d0 + &
                        coupl(nGC_59)**2d0 + coupl(nGC_63)**2d0 + coupl(nGC_75 &
                        )**2d0 + coupl(nGC_87)**2d0)/(16d0*pi**2d0*Nc)
      coupl(nGC_4640) = coupl(nGC_34)*dZbR_QCD2
      coupl(nGC_4647) = coupl(nGC_27)*dZA/2d0 + coupl(nGC_27)*dZH/2d0 + coupl( &
                        nGC_27)*dZWMinus/2d0 + coupl(nGC_3216) + coupl(nGC_8)* &
                        dZZA/2d0
      coupl(nGC_3119) = 3d0*cima*coupl(nGC_11)**3d0*sq2**3d0*(3d0*coupl(nGC_34 &
                        ) + 2d0*coupl(nGC_35) - 3d0*coupl(nGC_38) - 2d0*coupl( &
                        nGC_39))/(128d0*pi**2d0)
      coupl(nGC_3118) = cima*coupl(nGC_11)**3d0*sq2**3d0*(3d0*coupl(nGC_34) +  &
                        2d0*coupl(nGC_35) + 3d0*coupl(nGC_38) + 2d0*coupl(     &
                        nGC_39))/(384d0*pi**2d0)
      coupl(nGC_4642) = coupl(nGC_1)*dZAZ/2d0 + coupl(nGC_3301) + coupl(nGC_34 &
                        )*dZZ/2d0
      coupl(nGC_3297) = coupl(nGC_3294)*dZee + coupl(nGC_3295)*dsw_ + coupl(   &
                        nGC_3296)*dcw_
      coupl(nGC_3293) = coupl(nGC_3290)*dZee + coupl(nGC_3291)*dsw_ + coupl(   &
                        nGC_3292)*dcw_
      coupl(nGC_5066) = coupl(nGC_3469) + coupl(nGC_MZ_GF)*dZZ/2d0
      coupl(nGC_5639) = coupl(nGC_11)*dZbR_QCD2 + coupl(nGC_11)*dZg_QCD2/2d0 + &
                        coupl(nGC_3282)
      coupl(nGC_5738) = coupl(nGC_3365) + coupl(nGC_75)*dZH/2d0
      coupl(nGC_3061) = cMS*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_34)*coupl(    &
                        nGC_38))/(8d0*pi**2d0)
      coupl(nGC_3062) = cMB*cima*(-coupl(nGC_1)**2d0 - coupl(nGC_34)*coupl(    &
                        nGC_38))/(8d0*pi**2d0)
      coupl(nGC_3064) = cima*(-coupl(nGC_1)**2d0 - coupl(nGC_38)**2d0)/(16d0*pi&
                        **2d0)
      coupl(nGC_3067) = coupl(nGC_11)**2d0*coupl(nGC_39)*sq2**2d0*(Nc**2d0 -   &
                        1d0)/(32d0*pi**2d0*Nc)
      coupl(nGC_3069) = coupl(nGC_11)**2d0*coupl(nGC_38)*sq2**2d0*(Nc**2d0 -   &
                        1d0)/(32d0*pi**2d0*Nc)
      coupl(nGC_7815) = coupl(nGC_3459) + coupl(nGC_MS)*dZsL_QED2/2d0 + coupl( &
                        nGC_MS)*dZsR_QED2/2d0
      coupl(nGC_7816) = coupl(nGC_3460) + coupl(nGC_TS_GC_75_H)
      coupl(nGC_7817) = coupl(nGC_3461) + coupl(nGC_MS)*dZsL_QCD2/2d0 + coupl( &
                        nGC_MS)*dZsR_QCD2/2d0
      coupl(nGC_TS_GC_63_H) = -coupl(nGC_63)*dt/cMH**2d0
      coupl(nGC_3092) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_1)**2d0 + 4d0*coupl(  &
                        nGC_34)**2d0 + coupl(nGC_73)**2d0 + coupl(nGC_74)*coupl&
                        (nGC_76) + coupl(nGC_75)**2d0)/(64d0*pi**2d0)
      coupl(nGC_4762) = -coupl(nGC_19)*dZZA + coupl(nGC_29)*dZA/2d0 + coupl(   &
                        nGC_29)*dZWMinus + coupl(nGC_29)*dZZ/2d0 + coupl(      &
                        nGC_3158) - coupl(nGC_5)*dZAZ
      coupl(nGC_4761) = coupl(nGC_19)*dZZA/2d0 - coupl(nGC_29)*dZA/4d0 - coupl(&
                        nGC_29)*dZWMinus/2d0 - coupl(nGC_29)*dZZ/4d0 - coupl(  &
                        nGC_3158)/2d0 + coupl(nGC_5)*dZAZ/2d0
      coupl(nGC_3094) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_1)**2d0 - 4d0*coupl( &
                        nGC_34)**2d0 - coupl(nGC_54)*coupl(nGC_56) - coupl(    &
                        nGC_55)**2d0)/(64d0*pi**2d0*Nc)
      coupl(nGC_5555) = coupl(nGC_3349) + coupl(nGC_54)*dZbL_QCD2/2d0 + coupl( &
                        nGC_54)*dZbR_QCD2/2d0
      coupl(nGC_5992) = -coupl(nGC_22)*dZWMinus/2d0 - coupl(nGC_3223)
      coupl(nGC_5255) = coupl(nGC_23)*dZWMinus/2d0 + coupl(nGC_23)*dZeMinusL/  &
                        2d0 + coupl(nGC_23)*dZnu_eL/2d0 + coupl(nGC_3285)
      coupl(nGC_5399) = coupl(nGC_3309) + coupl(nGC_36)*dZZ/2d0 + coupl(nGC_36 &
                        )*dZtauMinusR + coupl(nGC_4)*dZAZ/2d0
      coupl(nGC_5252) = -coupl(nGC_25)*dZWMinus/2d0 - coupl(nGC_3151)
      coupl(nGC_7178) = coupl(nGC_3468) + coupl(nGC_MMW_GF)*dZWMinus/2d0
      coupl(nGC_5960) = coupl(nGC_MI)*dZuL_QCD2
      coupl(nGC_5969) = coupl(nGC_3449) + coupl(nGC_MU)*dZuL_QED2/2d0 + coupl( &
                        nGC_MU)*dZuR_QED2/2d0
      coupl(nGC_5782) = coupl(nGC_39)*dZuL_QED2
      coupl(nGC_5783) = coupl(nGC_39)*dZuL_QCD2
      coupl(nGC_5788) = coupl(nGC_3268) + coupl(nGC_46)*dZH + coupl(nGC_46)*dZZ
      coupl(nGC_4958) = coupl(nGC_1)*dZA/2d0 + coupl(nGC_3281) + coupl(nGC_38)*&
                        dZZA/2d0
      coupl(nGC_4810) = coupl(nGC_3377) + coupl(nGC_66)*dZeMinusL/2d0 + coupl( &
                        nGC_66)*dZeMinusR/2d0
      coupl(nGC_4957) = coupl(nGC_1)*dZA/2d0 + coupl(nGC_3281) + coupl(nGC_34)*&
                        dZZA/2d0
      coupl(nGC_3393) = coupl(nGC_3392)*dyup_QED3
      coupl(nGC_3391) = coupl(nGC_3390)*dytau_QED1
      coupl(nGC_3364) = coupl(nGC_3361)*dys_QED1_QCD2
      coupl(nGC_5778) = coupl(nGC_35)*dZuR_QED2
      coupl(nGC_3362) = coupl(nGC_3361)*dys_QED3
      coupl(nGC_3363) = coupl(nGC_3361)*dys_QED2
      coupl(nGC_3360) = coupl(nGC_3356)*dydo_QED1
      coupl(nGC_3247) = coupl(nGC_3244)*dZee + coupl(nGC_3245)*dsw_ + coupl(   &
                        nGC_3246)*dcw_
      coupl(nGC_3243) = coupl(nGC_3240)*dZee + coupl(nGC_3241)*dsw_ + coupl(   &
                        nGC_3242)*dcw_
      coupl(nGC_3025) = cima*(-6d0*Nc*coupl(nGC_1)*coupl(nGC_34) - 6d0*Nc*coupl&
                        (nGC_1)*coupl(nGC_38) - 4d0*Nc*coupl(nGC_2)*coupl(     &
                        nGC_35) - 4d0*Nc*coupl(nGC_2)*coupl(nGC_39) - 3d0*coupl&
                        (nGC_25)*coupl(nGC_3) - 3d0*coupl(nGC_313)*coupl(      &
                        nGC_451) - 6d0*coupl(nGC_36)*coupl(nGC_4) - 6d0*coupl( &
                        nGC_4)*coupl(nGC_40))/(96d0*pi**2d0)
      coupl(nGC_3024) = (4d0*Nc*cMB**2d0*cima*coupl(nGC_1)**2d0 + 4d0*Nc*cMC** &
                        2d0*cima*coupl(nGC_2)**2d0 + 4d0*Nc*cMD**2d0*cima*coupl&
                        (nGC_1)**2d0 + 4d0*Nc*cMS**2d0*cima*coupl(nGC_1)**2d0  &
                         + 4d0*Nc*cMU**2d0*cima*coupl(nGC_2)**2d0 + 4d0*cME**  &
                        2d0*cima*coupl(nGC_4)**2d0 + 4d0*cMM**2d0*cima*coupl(  &
                        nGC_4)**2d0 + 4d0*cMTA**2d0*cima*coupl(nGC_4)**2d0 +   &
                        3d0*cMW**2d0*cima*coupl(nGC_3)**2d0 + 3d0*cMW**2d0*cima&
                        *coupl(nGC_313)**2d0 - 2d0*cMW**2d0*coupl(nGC_363))/(  &
                        16d0*pi**2d0)
      coupl(nGC_3027) = (2d0*Nc*cMB**2d0*cima*coupl(nGC_1)*coupl(nGC_34) + 2d0*&
                        Nc*cMB**2d0*cima*coupl(nGC_1)*coupl(nGC_38) + 2d0*Nc*  &
                        cMC**2d0*cima*coupl(nGC_2)*coupl(nGC_35) + 2d0*Nc*cMC**&
                        2d0*cima*coupl(nGC_2)*coupl(nGC_39) + 2d0*Nc*cMD**2d0* &
                        cima*coupl(nGC_1)*coupl(nGC_34) + 2d0*Nc*cMD**2d0*cima*&
                        coupl(nGC_1)*coupl(nGC_38) + 2d0*Nc*cMS**2d0*cima*coupl&
                        (nGC_1)*coupl(nGC_34) + 2d0*Nc*cMS**2d0*cima*coupl(    &
                        nGC_1)*coupl(nGC_38) + 2d0*Nc*cMU**2d0*cima*coupl(nGC_2&
                        )*coupl(nGC_35) + 2d0*Nc*cMU**2d0*cima*coupl(nGC_2)*   &
                        coupl(nGC_39) + 2d0*cME**2d0*cima*coupl(nGC_36)*coupl( &
                        nGC_4) + 2d0*cME**2d0*cima*coupl(nGC_4)*coupl(nGC_40   &
                        ) + 2d0*cMM**2d0*cima*coupl(nGC_36)*coupl(nGC_4) + 2d0*&
                        cMM**2d0*cima*coupl(nGC_4)*coupl(nGC_40) + 2d0*cMTA**  &
                        2d0*cima*coupl(nGC_36)*coupl(nGC_4) + 2d0*cMTA**2d0*   &
                        cima*coupl(nGC_4)*coupl(nGC_40) + 3d0*cMW**2d0*cima*   &
                        coupl(nGC_25)*coupl(nGC_3) + 3d0*cMW**2d0*cima*coupl(  &
                        nGC_313)*coupl(nGC_451) - 2d0*cMW**2d0*coupl(nGC_29))/(&
                        16d0*pi**2d0)
      coupl(nGC_4738) = coupl(nGC_3268) + coupl(nGC_46)*dZZ
      coupl(nGC_4735) = coupl(nGC_13)*dZH + coupl(nGC_3201)
      coupl(nGC_3028) = cima*(-6d0*Nc*coupl(nGC_34)**2d0 - 4d0*Nc*coupl(nGC_35 &
                        )**2d0 - 6d0*Nc*coupl(nGC_38)**2d0 - 4d0*Nc*coupl(     &
                        nGC_39)**2d0 - 3d0*coupl(nGC_25)**2d0 - 6d0*coupl(     &
                        nGC_36)**2d0 - 6d0*coupl(nGC_40)**2d0 - 6d0*coupl(     &
                        nGC_41)**2d0 - 3d0*coupl(nGC_451)**2d0)/(96d0*pi**2d0)
      coupl(nGC_3418) = coupl(nGC_3417)*dyc_QED3
      coupl(nGC_3419) = coupl(nGC_3417)*dyc_QED2
      coupl(nGC_3414) = coupl(nGC_3412)*dyup_QED2
      coupl(nGC_3415) = coupl(nGC_3412)*dyup_QED1_QCD2
      coupl(nGC_3416) = coupl(nGC_3412)*dyup_QED1
      coupl(nGC_3410) = coupl(nGC_3407)*dyc_QED1_QCD2
      coupl(nGC_6856) = coupl(nGC_3413) + coupl(nGC_87)*dZuL_QED2/2d0 + coupl( &
                        nGC_87)*dZuR_QED2/2d0
      coupl(nGC_5033) = -coupl(nGC_24)*dZZA/2d0 - coupl(nGC_3164) - coupl(nGC_4&
                        )*dZA/2d0
      coupl(nGC_3090) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_1)**2d0 - 4d0*coupl( &
                        nGC_34)**2d0 - coupl(nGC_73)**2d0 - coupl(nGC_74)*coupl&
                        (nGC_76) - coupl(nGC_75)**2d0)/(64d0*pi**2d0*Nc)
      coupl(nGC_3091) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_1)**2d0 + 4d0*coupl(  &
                        nGC_23)**2d0 + 4d0*coupl(nGC_38)**2d0 + coupl(nGC_57)**&
                        2d0 + coupl(nGC_74)*coupl(nGC_76) + coupl(nGC_75)**2d0 &
                        )/(64d0*pi**2d0)
      coupl(nGC_5605) = coupl(nGC_3448) + coupl(nGC_MTA)*dZtauMinusL/2d0 +     &
                        coupl(nGC_MTA)*dZtauMinusR/2d0
      coupl(nGC_3093) = coupl(nGC_11)*sq2*(-4d0*coupl(nGC_1)**2d0 - 4d0*coupl( &
                        nGC_38)**2d0 - coupl(nGC_54)*coupl(nGC_56) - coupl(    &
                        nGC_55)**2d0)/(64d0*pi**2d0*Nc)
      coupl(nGC_6093) = -coupl(nGC_3247) - coupl(nGC_37)*dZH/2d0 - coupl(nGC_37&
                        )*dZZ/2d0
      coupl(nGC_3095) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_1)**2d0 + 4d0*coupl(  &
                        nGC_38)**2d0 + coupl(nGC_54)*coupl(nGC_56) + coupl(    &
                        nGC_55)**2d0)/(64d0*pi**2d0)
      coupl(nGC_3096) = coupl(nGC_11)*sq2*(4d0*coupl(nGC_1)**2d0 + 4d0*coupl(  &
                        nGC_34)**2d0 + coupl(nGC_54)*coupl(nGC_56) + coupl(    &
                        nGC_55)**2d0)/(64d0*pi**2d0)
      coupl(nGC_TS_GC_83_H) = -coupl(nGC_83)*dt/cMH**2d0
      coupl(nGC_4781) = coupl(nGC_34)*dZdR_QCD2
      coupl(nGC_4780) = coupl(nGC_34)*dZdR_QED2
      coupl(nGC_5215) = coupl(nGC_23)*dZWMinus/2d0 + coupl(nGC_23)*dZmuMinusL/ &
                        2d0 + coupl(nGC_23)*dZnu_muL/2d0 + coupl(nGC_3285)
      coupl(nGC_5355) = coupl(nGC_3385) + coupl(nGC_84)*dZtauMinusL/2d0 + coupl&
                        (nGC_84)*dZtauMinusR/2d0
      coupl(nGC_5356) = coupl(nGC_3383) + coupl(nGC_82)*dZtauMinusL/2d0 + coupl&
                        (nGC_82)*dZtauMinusR/2d0
      coupl(nGC_6329) = -coupl(nGC_21)*dZH/2d0 - coupl(nGC_21)*dZWMinus/2d0 -  &
                        coupl(nGC_3226)
      coupl(nGC_3068) = coupl(nGC_11)**2d0*coupl(nGC_35)*sq2**2d0*(Nc**2d0 -   &
                        1d0)/(32d0*pi**2d0*Nc)
      coupl(nGC_7679) = coupl(nGC_3457) + coupl(nGC_TS_GC_63_H)
    end subroutine fill_CTcouplings_mdl2
end module fill_ctcouplings2
