!******************************************************************************!
!                                                                              !
!    ctparameter101.f90                                                        !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter101.f90                             |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter101
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter101()
  if (dMS_QED2_scheme .eq. 0) then
    dMS_QED2 = -(-coupl(nGC_MI)*(4d0*Ten108*cMS*coupl(nGC_1)**2d0 - 2d0*Ten109*&
               cMS*coupl(nGC_34)**2d0 + 8d0*Ten109*cMS*coupl(nGC_34)*coupl(    &
               nGC_38) - 2d0*Ten109*cMS*coupl(nGC_38)**2d0 - Ten109*cMS*coupl( &
               nGC_74)**2d0 - 2d0*Ten109*cMS*coupl(nGC_74)*coupl(nGC_76) -     &
               Ten109*cMS*coupl(nGC_76)**2d0 - 2d0*Ten110*cMC*coupl(nGC_57)*   &
               coupl(nGC_73) - 2d0*Ten110*cMS*coupl(nGC_23)**2d0 - Ten110*cMS* &
               coupl(nGC_57)**2d0 - Ten110*cMS*coupl(nGC_73)**2d0 + 2d0*Ten111*&
               cMS*coupl(nGC_75)**2d0 - 4d0*Ten112*cMS*coupl(nGC_1)**2d0 - 2d0*&
               Ten113*cMS*coupl(nGC_34)**2d0 - 2d0*Ten113*cMS*coupl(nGC_38)**  &
               2d0 - 2d0*Ten113*cMS*coupl(nGC_74)*coupl(nGC_76) - 2d0*Ten114*  &
               cMS*coupl(nGC_23)**2d0 - Ten114*cMS*coupl(nGC_57)**2d0 - Ten114*&
               cMS*coupl(nGC_73)**2d0 - 2d0*Ten115*cMS*coupl(nGC_75)**2d0 - 2d0&
               *cMS*coupl(nGC_1)**2d0 + cMS*coupl(nGC_23)**2d0 + cMS*coupl(    &
               nGC_34)**2d0 - 4d0*cMS*coupl(nGC_34)*coupl(nGC_38) + cMS*coupl( &
               nGC_38)**2d0) - (-cMS*coupl(nGC_MI) + coupl(nGC_MS))*(-4d0*     &
               Ten108*coupl(nGC_1)**2d0 - 2d0*Ten109*coupl(nGC_34)**2d0 - 2d0* &
               Ten109*coupl(nGC_38)**2d0 - 2d0*Ten109*coupl(nGC_74)*coupl(     &
               nGC_76) - 2d0*Ten110*coupl(nGC_23)**2d0 - Ten110*coupl(nGC_57)**&
               2d0 - Ten110*coupl(nGC_73)**2d0 + 2d0*Ten111*coupl(nGC_75)**2d0 &
                - 4d0*Ten112*coupl(nGC_1)**2d0 - 2d0*Ten113*coupl(nGC_34)**2d0 &
                - 2d0*Ten113*coupl(nGC_38)**2d0 - 2d0*Ten113*coupl(nGC_74)*    &
               coupl(nGC_76) - 2d0*Ten114*coupl(nGC_23)**2d0 - Ten114*coupl(   &
               nGC_57)**2d0 - Ten114*coupl(nGC_73)**2d0 - 4d0*Ten116*cMS**2d0* &
               coupl(nGC_75)**2d0 + 8d0*Ten117*cMS**2d0*coupl(nGC_1)**2d0 - 4d0&
               *Ten118*cMS**2d0*coupl(nGC_34)**2d0 + 16d0*Ten118*cMS**2d0*coupl&
               (nGC_34)*coupl(nGC_38) - 4d0*Ten118*cMS**2d0*coupl(nGC_38)**2d0 &
                - 2d0*Ten118*cMS**2d0*coupl(nGC_74)**2d0 - 4d0*Ten118*cMS**2d0*&
               coupl(nGC_74)*coupl(nGC_76) - 2d0*Ten118*cMS**2d0*coupl(nGC_76  &
               )**2d0 - 4d0*Ten119*cMC*cMS*coupl(nGC_57)*coupl(nGC_73) - 4d0*  &
               Ten119*cMS**2d0*coupl(nGC_23)**2d0 - 2d0*Ten119*cMS**2d0*coupl( &
               nGC_57)**2d0 - 2d0*Ten119*cMS**2d0*coupl(nGC_73)**2d0 + 4d0*    &
               Ten120*cMS**2d0*coupl(nGC_75)**2d0 - 8d0*Ten121*cMS**2d0*coupl( &
               nGC_1)**2d0 - 4d0*Ten122*cMS**2d0*coupl(nGC_34)**2d0 - 4d0*     &
               Ten122*cMS**2d0*coupl(nGC_38)**2d0 - 4d0*Ten122*cMS**2d0*coupl( &
               nGC_74)*coupl(nGC_76) - 4d0*Ten123*cMS**2d0*coupl(nGC_23)**2d0  &
                - 2d0*Ten123*cMS**2d0*coupl(nGC_57)**2d0 - 2d0*Ten123*cMS**2d0*&
               coupl(nGC_73)**2d0 + 2d0*coupl(nGC_1)**2d0 + coupl(nGC_23)**2d0 &
                + coupl(nGC_34)**2d0 + coupl(nGC_38)**2d0))/(32d0*pi**2d0*coupl&
               (nGC_MI))
    dMS_QED2 = cone*real(dMS_QED2,kind=dp)
  end if 
end subroutine set_ctparameter101
end module ctparameter101
