!******************************************************************************!
!                                                                              !
!    ctparameter18.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter18.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter18
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter18()
  if (dMC_QCD2_scheme .eq. 0) then
    dMC_QCD2 = sq2**2d0*(-8d0*pi*aS*coupl(nGC_MI)*(Nc**2d0 - 1d0)*(cMC - rMC)*(&
               cMC + rMC) - coupl(nGC_11)**2d0*rMC*(-coupl(nGC_MI)*(4d0*Nc**2d0&
               *Ten74*cMC - 2d0*Nc**2d0*Ten74*rMC - 2d0*Nc**2d0*Ten78*rMC - 2d0&
               *Nc**2d0*cMC + Nc**2d0*rMC - 4d0*Ten74*cMC + 2d0*Ten74*rMC + 2d0&
               *Ten78*rMC + 2d0*cMC - rMC) - (coupl(nGC_MC) - coupl(nGC_MI)*rMC&
               )*(-2d0*Nc**2d0*Ten74 - 2d0*Nc**2d0*Ten78 + 8d0*Nc**2d0*Ten83*  &
               cMC*rMC - 4d0*Nc**2d0*Ten83*rMC**2d0 - 4d0*Nc**2d0*Ten87*rMC**  &
               2d0 + Nc**2d0 + 2d0*Ten74 + 2d0*Ten78 - 8d0*Ten83*cMC*rMC + 4d0*&
               Ten83*rMC**2d0 + 4d0*Ten87*rMC**2d0 - 1d0)))/(64d0*pi**2d0*Nc*  &
               coupl(nGC_MI)*rMC)
    if (.not. complex_mass_scheme) then
      dMC_QCD2 = cone*real(dMC_QCD2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter18
end module ctparameter18
