!******************************************************************************!
!                                                                              !
!    ctparameter45.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter45.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter45
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter45()
  if (dMU_QCD2_scheme .eq. 0) then
    dMU_QCD2 = coupl(nGC_11)**2d0*sq2**2d0*(cMU*coupl(nGC_MI)*(2d0*Nc**2d0*    &
               Ten36 - 2d0*Nc**2d0*Ten40 - Nc**2d0 - 2d0*Ten36 + 2d0*Ten40 +   &
               1d0) + (-cMU*coupl(nGC_MI) + coupl(nGC_MU))*(-2d0*Nc**2d0*Ten36 &
                - 2d0*Nc**2d0*Ten40 + 4d0*Nc**2d0*Ten45*cMU**2d0 - 4d0*Nc**2d0*&
               Ten49*cMU**2d0 + Nc**2d0 + 2d0*Ten36 + 2d0*Ten40 - 4d0*Ten45*cMU&
               **2d0 + 4d0*Ten49*cMU**2d0 - 1d0))/(64d0*pi**2d0*Nc*coupl(nGC_MI&
               ))
    dMU_QCD2 = cone*real(dMU_QCD2,kind=dp)
  end if 
end subroutine set_ctparameter45
end module ctparameter45
