!******************************************************************************!
!                                                                              !
!    ctparameter54.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter54.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter54
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter54()
  if (dMD_QED2_scheme .eq. 0) then
    dMD_QED2 = (coupl(nGC_MI)*(4d0*Ten56*cMD*coupl(nGC_1)**2d0 - 2d0*Ten57*cMD*&
               coupl(nGC_34)**2d0 + 8d0*Ten57*cMD*coupl(nGC_34)*coupl(nGC_38   &
               ) - 2d0*Ten57*cMD*coupl(nGC_38)**2d0 - Ten57*cMD*coupl(nGC_62)**&
               2d0 - 2d0*Ten57*cMD*coupl(nGC_62)*coupl(nGC_64) - Ten57*cMD*    &
               coupl(nGC_64)**2d0 - 2d0*Ten58*cMD*coupl(nGC_23)**2d0 - Ten58*  &
               cMD*coupl(nGC_61)**2d0 - Ten58*cMD*coupl(nGC_85)**2d0 - 2d0*    &
               Ten58*cMU*coupl(nGC_61)*coupl(nGC_85) + 2d0*Ten59*cMD*coupl(    &
               nGC_63)**2d0 - 4d0*Ten60*cMD*coupl(nGC_1)**2d0 - 2d0*Ten61*cMD* &
               coupl(nGC_34)**2d0 - 2d0*Ten61*cMD*coupl(nGC_38)**2d0 - 2d0*    &
               Ten61*cMD*coupl(nGC_62)*coupl(nGC_64) - 2d0*Ten62*cMD*coupl(    &
               nGC_23)**2d0 - Ten62*cMD*coupl(nGC_61)**2d0 - Ten62*cMD*coupl(  &
               nGC_85)**2d0 - 2d0*Ten63*cMD*coupl(nGC_63)**2d0 - 2d0*cMD*coupl(&
               nGC_1)**2d0 + cMD*coupl(nGC_23)**2d0 + cMD*coupl(nGC_34)**2d0 - &
               4d0*cMD*coupl(nGC_34)*coupl(nGC_38) + cMD*coupl(nGC_38)**2d0    &
               ) + (-cMD*coupl(nGC_MI) + coupl(nGC_MD))*(-4d0*Ten56*coupl(nGC_1&
               )**2d0 - 2d0*Ten57*coupl(nGC_34)**2d0 - 2d0*Ten57*coupl(nGC_38  &
               )**2d0 - 2d0*Ten57*coupl(nGC_62)*coupl(nGC_64) - 2d0*Ten58*coupl&
               (nGC_23)**2d0 - Ten58*coupl(nGC_61)**2d0 - Ten58*coupl(nGC_85)**&
               2d0 + 2d0*Ten59*coupl(nGC_63)**2d0 - 4d0*Ten60*coupl(nGC_1)**2d0&
                - 2d0*Ten61*coupl(nGC_34)**2d0 - 2d0*Ten61*coupl(nGC_38)**2d0  &
                - 2d0*Ten61*coupl(nGC_62)*coupl(nGC_64) - 2d0*Ten62*coupl(     &
               nGC_23)**2d0 - Ten62*coupl(nGC_61)**2d0 - Ten62*coupl(nGC_85)** &
               2d0 - 4d0*Ten64*cMD**2d0*coupl(nGC_63)**2d0 + 8d0*Ten65*cMD**2d0&
               *coupl(nGC_1)**2d0 - 4d0*Ten66*cMD**2d0*coupl(nGC_34)**2d0 +    &
               16d0*Ten66*cMD**2d0*coupl(nGC_34)*coupl(nGC_38) - 4d0*Ten66*cMD &
               **2d0*coupl(nGC_38)**2d0 - 2d0*Ten66*cMD**2d0*coupl(nGC_62)**2d0&
                - 4d0*Ten66*cMD**2d0*coupl(nGC_62)*coupl(nGC_64) - 2d0*Ten66*  &
               cMD**2d0*coupl(nGC_64)**2d0 - 4d0*Ten67*cMD**2d0*coupl(nGC_23)**&
               2d0 - 2d0*Ten67*cMD**2d0*coupl(nGC_61)**2d0 - 2d0*Ten67*cMD**2d0&
               *coupl(nGC_85)**2d0 - 4d0*Ten67*cMD*cMU*coupl(nGC_61)*coupl(    &
               nGC_85) + 4d0*Ten68*cMD**2d0*coupl(nGC_63)**2d0 - 8d0*Ten69*cMD &
               **2d0*coupl(nGC_1)**2d0 - 4d0*Ten70*cMD**2d0*coupl(nGC_34)**2d0 &
                - 4d0*Ten70*cMD**2d0*coupl(nGC_38)**2d0 - 4d0*Ten70*cMD**2d0*  &
               coupl(nGC_62)*coupl(nGC_64) - 4d0*Ten71*cMD**2d0*coupl(nGC_23)**&
               2d0 - 2d0*Ten71*cMD**2d0*coupl(nGC_61)**2d0 - 2d0*Ten71*cMD**2d0&
               *coupl(nGC_85)**2d0 + 2d0*coupl(nGC_1)**2d0 + coupl(nGC_23)**2d0&
                + coupl(nGC_34)**2d0 + coupl(nGC_38)**2d0))/(32d0*pi**2d0*coupl&
               (nGC_MI))
    dMD_QED2 = cone*real(dMD_QED2,kind=dp)
  end if 
end subroutine set_ctparameter54
end module ctparameter54
