!******************************************************************************!
!                                                                              !
!    ctparameter57.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter57.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter57
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter57()
  dZg_QCD2 = -cima*sq2**2d0*(5d0*Nc*Ten0*coupl(nGC_10)**2d0 + 12d0*Ten21*      &
             cMU_reg**2d0*coupl(nGC_11)**2d0 + 12d0*Ten22*cMC_reg**2d0*coupl(  &
             nGC_11)**2d0 + 12d0*Ten23*cMD_reg**2d0*coupl(nGC_11)**2d0 + 12d0* &
             Ten24*cMS_reg**2d0*coupl(nGC_11)**2d0 + 12d0*Ten25*cMB_reg**2d0*  &
             coupl(nGC_11)**2d0 - 24d0*Ten26*coupl(nGC_11)**2d0 - 24d0*Ten27*  &
             coupl(nGC_11)**2d0 - 24d0*Ten28*coupl(nGC_11)**2d0 - 24d0*Ten29*  &
             coupl(nGC_11)**2d0 - 24d0*Ten30*coupl(nGC_11)**2d0 - 2d0*Ten31*   &
             coupl(nGC_11)**2d0 - 2d0*Ten32*coupl(nGC_11)**2d0 - 2d0*Ten33*    &
             coupl(nGC_11)**2d0 - 2d0*Ten34*coupl(nGC_11)**2d0 - 2d0*Ten35*    &
             coupl(nGC_11)**2d0)/(96d0*pi**2d0*coupl(nGC_MI))
  dZg_QCD2 = cone*real(dZg_QCD2,kind=dp)
end subroutine set_ctparameter57
end module ctparameter57
