!******************************************************************************!
!                                                                              !
!    ctparameter76.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter76.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter76
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter76()
  DeltaUV = DeltaUV + log(muUV**2/muMS**2)
  dZgs_QCD2 = cima*DeltaUV*coupl(nGC_11)*sq2**2d0*(36d0*cima*Nc**2d0*coupl(    &
              nGC_10)*coupl(nGC_11)*coupl(nGC_MI) - cima*Nc*(20d0*Nc*coupl(    &
              nGC_10)**2d0 + 40d0*coupl(nGC_11)**2d0) + 12d0*coupl(nGC_11)**2d0&
              *coupl(nGC_MI) - 12d0*cima*coupl(nGC_11)**2d0*(Nc**2d0 - 1d0))/( &
              768d0*pi**2d0*Nc*coupl(nGC_MI)*gs)
  dZgs_QCD2 = cone*real(dZgs_QCD2,kind=dp)
  DeltaUV = DeltaUV - log(muUV**2/muMS**2)
end subroutine set_ctparameter76
end module ctparameter76
