!******************************************************************************!
!                                                                              !
!    ctparameter89.f90                                                         !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter89.f90                              |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter89
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter89()
  if (dMB_QED2_scheme .eq. 0) then
    dMB_QED2 = (-16d0*pi*aEW*coupl(nGC_MI)*(cMB - rMB)*(cMB + rMB) - 9d0*rMB*(-&
               coupl(nGC_MI)*(8d0*Ten126*cMB*coupl(nGC_1)**2d0 - 4d0*Ten126*   &
               coupl(nGC_1)**2d0*rMB + 8d0*Ten127*cMB*coupl(nGC_34)*coupl(     &
               nGC_38) - Ten127*cMB*coupl(nGC_54)**2d0 - Ten127*cMB*coupl(     &
               nGC_56)**2d0 - 2d0*Ten127*coupl(nGC_34)**2d0*rMB - 2d0*Ten127*  &
               coupl(nGC_38)**2d0*rMB - 2d0*Ten127*coupl(nGC_54)*coupl(nGC_56)*&
               rMB + 2d0*Ten128*coupl(nGC_55)**2d0*rMB - 4d0*Ten129*coupl(nGC_1&
               )**2d0*rMB - 2d0*Ten130*coupl(nGC_34)**2d0*rMB - 2d0*Ten130*    &
               coupl(nGC_38)**2d0*rMB - 2d0*Ten130*coupl(nGC_54)*coupl(nGC_56)*&
               rMB - 2d0*Ten131*cMB*coupl(nGC_55)**2d0 - 4d0*cMB*coupl(nGC_1)**&
               2d0 - 4d0*cMB*coupl(nGC_34)*coupl(nGC_38) + 2d0*coupl(nGC_1)**  &
               2d0*rMB + coupl(nGC_34)**2d0*rMB + coupl(nGC_38)**2d0*rMB) - (  &
               coupl(nGC_MB) - coupl(nGC_MI)*rMB)*(-4d0*Ten126*coupl(nGC_1)**  &
               2d0 - 2d0*Ten127*coupl(nGC_34)**2d0 - 2d0*Ten127*coupl(nGC_38)**&
               2d0 - 2d0*Ten127*coupl(nGC_54)*coupl(nGC_56) + 2d0*Ten128*coupl(&
               nGC_55)**2d0 - 4d0*Ten129*coupl(nGC_1)**2d0 - 2d0*Ten130*coupl( &
               nGC_34)**2d0 - 2d0*Ten130*coupl(nGC_38)**2d0 - 2d0*Ten130*coupl(&
               nGC_54)*coupl(nGC_56) - 4d0*Ten132*cMB*coupl(nGC_55)**2d0*rMB + &
               16d0*Ten133*cMB*coupl(nGC_1)**2d0*rMB - 8d0*Ten133*coupl(nGC_1  &
               )**2d0*rMB**2d0 + 16d0*Ten134*cMB*coupl(nGC_34)*coupl(nGC_38)*  &
               rMB - 2d0*Ten134*cMB*coupl(nGC_54)**2d0*rMB - 2d0*Ten134*cMB*   &
               coupl(nGC_56)**2d0*rMB - 4d0*Ten134*coupl(nGC_34)**2d0*rMB**2d0 &
                - 4d0*Ten134*coupl(nGC_38)**2d0*rMB**2d0 - 4d0*Ten134*coupl(   &
               nGC_54)*coupl(nGC_56)*rMB**2d0 + 4d0*Ten135*coupl(nGC_55)**2d0* &
               rMB**2d0 - 8d0*Ten136*coupl(nGC_1)**2d0*rMB**2d0 - 4d0*Ten137*  &
               coupl(nGC_34)**2d0*rMB**2d0 - 4d0*Ten137*coupl(nGC_38)**2d0*rMB &
               **2d0 - 4d0*Ten137*coupl(nGC_54)*coupl(nGC_56)*rMB**2d0 + 2d0*  &
               coupl(nGC_1)**2d0 + coupl(nGC_34)**2d0 + coupl(nGC_38)**2d0)))/(&
               288d0*pi**2d0*coupl(nGC_MI)*rMB)
    if (.not. complex_mass_scheme) then
      dMB_QED2 = cone*real(dMB_QED2,kind=dp)
    end if 
  end if 
end subroutine set_ctparameter89
end module ctparameter89
