!******************************************************************************!
!                                                                              !
!    derived_ctparameter.f90                                                   !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   derived_ctparameter.f90                        |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module derived_ctparameter
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_derived_ctparameter()
  dsw2_ = cw**2d0*(cw**2d0*dMZ2 - dMW2)/cMW**2d0
  dsw_ = cw**2d0*(cw**2d0*dMZ2 - dMW2)/(2d0*cMW**2d0*sw)
  dlam_QED2 = gw**2d0*(2d0*cMH**2d0*cMW**2d0*dZee - cMH**2d0*cw**4d0*dMZ2 - cMH&
              **2d0*dMW2 + cMW**2d0*dMH2 - cw**2d0*(2d0*cMH**2d0*cMW**2d0*dZee &
               - 2d0*cMH**2d0*dMW2 + cMW**2d0*dMH2))/(2d0*cMW**4d0*sw**2d0)
  dcw_ = -cw*(cw**2d0*dMZ2 - dMW2)/(2d0*cMW**2d0)
  dg1_QED1 = -gw*sw*(2d0*cMW**2d0*dZee + cw**2d0*dMZ2 - dMW2)/(4d0*cMW**2d0*cw)
  dys_QED3 = -sqrt(2d0)*dMS_QED2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0  &
              - 2d0*cw**2d0 + 1d0))
  dys_QED1_QCD2 = -sqrt(2d0)*dMS_QCD2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**&
                  4d0 - 2d0*cw**2d0 + 1d0))
  dys_QED2 = -sqrt(2d0)*dMS_QED1*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0  &
              - 2d0*cw**2d0 + 1d0))
  dys_QED1 = -sqrt(2d0)*cMS*gw*sw**2d0*(-2d0*cMW**2d0*dZee + cw**4d0*dMZ2 + 2d0&
             *cw**2d0*(cMW**2d0*dZee - dMW2) + dMW2)/(4d0*cMW**3d0*(cw**4d0 -  &
             2d0*cw**2d0 + 1d0))
  dytau_QED1 = -sqrt(2d0)*gw*sw**2d0*(-2d0*cMTA*cMW**2d0*dZee + cMTA*cw**4d0*  &
               dMZ2 + cMTA*dMW2 - 2d0*cMW**2d0*dMTA + 2d0*cw**2d0*(cMTA*cMW**  &
               2d0*dZee - cMTA*dMW2 + cMW**2d0*dMTA))/(4d0*cMW**3d0*(cw**4d0 - &
               2d0*cw**2d0 + 1d0))
  dym_QED1 = -sqrt(2d0)*gw*sw**2d0*(-2d0*cMM*cMW**2d0*dZee + cMM*cw**4d0*dMZ2  &
              + cMM*dMW2 - 2d0*cMW**2d0*dMM + 2d0*cw**2d0*(cMM*cMW**2d0*dZee - &
             cMM*dMW2 + cMW**2d0*dMM))/(4d0*cMW**3d0*(cw**4d0 - 2d0*cw**2d0 +  &
             1d0))
  dvev_QEDM1 = (-2d0*cMW**2d0*dZee + cw**4d0*dMZ2 + 2d0*cw**2d0*(cMW**2d0*dZee &
                - dMW2) + dMW2)/(cMW*gw*sw**2d0)
  dgw_QED1 = gw*(2d0*cMW**2d0*dZee*sw**2d0 - cw**4d0*dMZ2 + cw**2d0*dMW2)/(2d0*&
             cMW**2d0*sw**2d0)
  dmuH2_ = dMH2/2d0
  dyt_QED1 = -sqrt(2d0)*gw*sw**2d0*(-2d0*cMT*cMW**2d0*dZee + cMT*cw**4d0*dMZ2  &
              + cMT*dMW2 - 2d0*cMW**2d0*dMT + 2d0*cw**2d0*(cMT*cMW**2d0*dZee - &
             cMT*dMW2 + cMW**2d0*dMT))/(4d0*cMW**3d0*(cw**4d0 - 2d0*cw**2d0 +  &
             1d0))
  dye_QED1 = -sqrt(2d0)*gw*sw**2d0*(-2d0*cME*cMW**2d0*dZee + cME*cw**4d0*dMZ2  &
              + cME*dMW2 - 2d0*cMW**2d0*dME + 2d0*cw**2d0*(cME*cMW**2d0*dZee - &
             cME*dMW2 + cMW**2d0*dME))/(4d0*cMW**3d0*(cw**4d0 - 2d0*cw**2d0 +  &
             1d0))
  dydo_QED3 = -sqrt(2d0)*dMD_QED2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0 &
               - 2d0*cw**2d0 + 1d0))
  dydo_QED1 = -sqrt(2d0)*cMD*gw*sw**2d0*(-2d0*cMW**2d0*dZee + cw**4d0*dMZ2 +   &
              2d0*cw**2d0*(cMW**2d0*dZee - dMW2) + dMW2)/(4d0*cMW**3d0*(cw**4d0&
               - 2d0*cw**2d0 + 1d0))
  dydo_QED2 = -sqrt(2d0)*dMD_QED1*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0 &
               - 2d0*cw**2d0 + 1d0))
  dydo_QED1_QCD2 = -sqrt(2d0)*dMD_QCD2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw &
                   **4d0 - 2d0*cw**2d0 + 1d0))
  dyup_QED3 = -sqrt(2d0)*dMU_QED2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0 &
               - 2d0*cw**2d0 + 1d0))
  dyup_QED1 = -sqrt(2d0)*cMU*gw*sw**2d0*(-2d0*cMW**2d0*dZee + cw**4d0*dMZ2 +   &
              2d0*cw**2d0*(cMW**2d0*dZee - dMW2) + dMW2)/(4d0*cMW**3d0*(cw**4d0&
               - 2d0*cw**2d0 + 1d0))
  dyup_QED2 = -sqrt(2d0)*dMU_QED1*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0 &
               - 2d0*cw**2d0 + 1d0))
  dyup_QED1_QCD2 = -sqrt(2d0)*dMU_QCD2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw &
                   **4d0 - 2d0*cw**2d0 + 1d0))
  dyb_QED3 = -sqrt(2d0)*dMB_QED2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0  &
              - 2d0*cw**2d0 + 1d0))
  dyb_QED1_QCD2 = -sqrt(2d0)*dMB_QCD2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**&
                  4d0 - 2d0*cw**2d0 + 1d0))
  dyb_QED1 = -sqrt(2d0)*cMB*gw*sw**2d0*(-2d0*cMW**2d0*dZee + cw**4d0*dMZ2 + 2d0&
             *cw**2d0*(cMW**2d0*dZee - dMW2) + dMW2)/(4d0*cMW**3d0*(cw**4d0 -  &
             2d0*cw**2d0 + 1d0))
  dyb_QED2 = -sqrt(2d0)*dMB_QED1*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0  &
              - 2d0*cw**2d0 + 1d0))
  dyc_QED3 = -sqrt(2d0)*dMC_QED2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0  &
              - 2d0*cw**2d0 + 1d0))
  dyc_QED1_QCD2 = -sqrt(2d0)*dMC_QCD2*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**&
                  4d0 - 2d0*cw**2d0 + 1d0))
  dyc_QED2 = -sqrt(2d0)*dMC_QED1*gw*sw**2d0*(cw**2d0 - 1d0)/(2d0*cMW*(cw**4d0  &
              - 2d0*cw**2d0 + 1d0))
  dyc_QED1 = -sqrt(2d0)*cMC*gw*sw**2d0*(-2d0*cMW**2d0*dZee + cw**4d0*dMZ2 + 2d0&
             *cw**2d0*(cMW**2d0*dZee - dMW2) + dMW2)/(4d0*cMW**3d0*(cw**4d0 -  &
             2d0*cw**2d0 + 1d0))
end subroutine set_derived_ctparameter
end module derived_ctparameter
