!******************************************************************************!
!                                                                              !
!    fcSFaF2.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fcSFaF2.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fcSFaF2
  use class_vertices
  implicit none

  contains

  subroutine formSFaF2(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last,   &
  cgs, cw, cj, C, m, p)
    integer, intent(in) :: ty, legs, nDef, ind, e(:)
    logical, intent(in) :: cou(:), last
    character(len=*), intent(in) :: den, denGSB, cgs, cw(:), cj, C
    character(len=5), intent(in) :: m(1:nDef)
    character(len=7), intent(in) :: rxip
    character(len=10), intent(in) :: p(1:nDef)
    character(len=80) :: indent=''
    select case(ty)
    case(SFaF2)
!   c0 x (
!   + ProjP(2,3)
!   )
    if (last .and. e(nDef) .lt. 2**legs) then
      write(999,'(a)') indent(1:ind) //'d_(j' // trim(cj) // ',i' // trim(cw(  &
      ndef)) // ') * ('
    else
      write(999,'(a)') indent(1:ind) // 'i_ * ( '// '- ga(j' // trim(cj        &
      ) // ',i' // trim(cw(ndef)) // ',' //trim(p(nDef                         &
      )) // ') ' // '+ d_(j' // trim(cj) // ',i' // trim(cw(ndef)) // ')*'//   &
      trim(m(nDef))//' '// ') * '//trim(den)//' * ('
    end if 
    if (cou(1)) then
      write(999,'(a)') indent(1:ind)//'+ '// C//'(1,'//trim(cgs                &
      )//')'//' * ('// '+' // 'op(i' // trim(cw(2)) // ',j' // trim(cj         &
      ) // ')' // ')'
    end if 
    write(999,'(a)') indent(1:ind)// ') ;'
    write(999,'(a)')
    write(999,'(a)') '.sort'
    write(999,'(a)')
    end select 
  end subroutine formSFaF2
end module fcSFaF2
