!******************************************************************************!
!                                                                              !
!    fcVV0.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fcVV0.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fcVV0
  use class_vertices
  implicit none

  contains

  subroutine formVV0(ty, legs, nDef, ind, e, cou, den, denGSB, rxip, last, cgs &
  , cw, cj, C, m, p)
    integer, intent(in) :: ty, legs, nDef, ind, e(:)
    logical, intent(in) :: cou(:), last
    character(len=*), intent(in) :: den, denGSB, cgs, cw(:), cj, C
    character(len=5), intent(in) :: m(1:nDef)
    character(len=7), intent(in) :: rxip
    character(len=10), intent(in) :: p(1:nDef)
    character(len=80) :: indent=''
    select case(ty)
    case(VV0)
!   c0 x (
!   - P(1,2)*P(2,2)
!   )
!   c1 x (
!   - P(1,1)*P(2,1)
!   )
!   c2 x (
!   + P(-1,2)*P(-1,2)*Metric(1,2)
!   )
!   c3 x (
!   + P(-1,1)*P(-1,1)*Metric(1,2)
!   )
!   c4 x (
!   + Metric(1,2)
!   )
    if (last .and. e(nDef) .lt. 2**legs) then
      write(999,'(a)') indent(1:ind) //'d_(mu' // trim(cw(ndef)) // ',nu' //   &
      trim(cj) // ') * ('
    else
      write(999,'(a)') indent(1:ind) // ' ( '// 'd_(mu' // trim(cw(ndef        &
      )) // ',nu' // trim(cj) // ') ' // ') * (-i_) *' //trim(den)// ' * ('
    end if 
    if (cou(1)) then
      write(999,'(a)') indent(1:ind)//'+ '// C//'(1,'//trim(cgs                &
      )//')'//' * (' // '-1*' //trim(p(nDef)) // '(mu' //trim(cw(1             &
      )) // ')' // '*' // trim(p(nDef)) // '(nu' //trim(cj) // ')' // ')'
    end if 
    if (cou(2)) then
      write(999,'(a)') indent(1:ind)//'+ '// C//'(2,'//trim(cgs                &
      )//')'//' * (' // '-1*' // '(-1)*' // trim(p(1)) // '(mu' //trim(cw(1    &
      )) // ')' // '*' //  '(-1)*' // trim(p(1)) // '(nu' //trim(cj            &
      ) // ')' // ')'
    end if 
    if (cou(3)) then
      write(999,'(a)') indent(1:ind)//'+ '// C//'(3,'//trim(cgs                &
      )//')'//' * ('// '+' //trim(p(nDef)) // '(ro' //trim(cj                  &
      ) // ')' // '*' // trim(p(nDef)) // '(ro' //trim(cj                      &
      ) // ')' // '*' //  'd_(mu' // trim(cw(1)) // ',nu' // trim(cj           &
      ) // ')' // ')'
    end if 
    if (cou(4)) then
      write(999,'(a)') indent(1:ind)//'+ '// C//'(4,'//trim(cgs                &
      )//')'//' * ('// '+' // '(-1)*' // trim(p(1)) // '(ro' //trim(cj         &
      ) // ')' // '*' //  '(-1)*' // trim(p(1)) // '(ro' //trim(cj             &
      ) // ')' // '*' //  'd_(mu' // trim(cw(1)) // ',nu' // trim(cj           &
      ) // ')' // ')'
    end if 
    if (cou(5)) then
      write(999,'(a)') indent(1:ind)//'+ '// C//'(5,'//trim(cgs                &
      )//')'//' * ('// '+' // 'd_(mu' // trim(cw(1)) // ',nu' // trim(cj       &
      ) // ')' // ')'
    end if 
    write(999,'(a)') indent(1:ind)// ') ;'
    write(999,'(a)')
    write(999,'(a)') '.sort'
    write(999,'(a)')
    end select 
  end subroutine formVV0
end module fcVV0
