!******************************************************************************!
!                                                                              !
!    tcFaF0.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFaF0.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFaF0
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec
  contains
    subroutine treeFaF0(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FaF0)
!       GammaP(-1,1,2)*P(-1,2)*c0
!       GammaM(-1,1,2)*P(-1,2)*c1
    if (last .eqv. .false.) then
      pl(:) = PL1(:)
      x0 = pl(1)*w1(0)
      x1 = pl(2)*w1(1)
      x2 = P1(0)*co(1)
      x3 = pl(1)*w1(1)
      x4 = pl(2)*w1(0)
      x5 = P1(1)*co(1)
      x6 = P1(3)*co(1)
      x7 = P1(1)*co(0)
      x8 = m*w1(3)
      x9 = P1(3)*co(0)
      x10 = m*w1(2)
      x11 = P1(0)*co(0)
      x12 = P1(2)*cima*co(1)
      x13 = P1(2)*cima*co(0)
      x14 = pl(0)*w1(1)
      x15 = pl(3)*w1(0)
      x16 = pl(0)*w1(0)
      x17 = pl(3)*w1(1)
      x18 = pl(0)*w1(3)
      x19 = pl(2)*w1(2)
      x20 = pl(0)*w1(2)
      x21 = pl(2)*w1(3)
      x22 = m*w1(0)
      x23 = m*w1(1)
      x24 = pl(1)*w1(2)
      x25 = pl(3)*w1(3)
      x26 = pl(1)*w1(3)
      x27 = pl(3)*w1(2)
      wout(0) = -x10*x11 + x10*x9 - x12*(x3 + x4) + x13*x8 - x2*(x0 - x1) - x5 &
                *(x3 - x4) - x6*(x0 + x1) + x7*x8
      wout(1) = -x10*x13 + x10*x7 - x11*x8 + x12*(x16 + x17) - x2*(x14 - x15   &
                ) - x5*(x16 - x17) + x6*(x14 + x15) - x8*x9
      wout(2) = -x11*(x20 + x21) - x12*x23 + x13*(x18 - x19) - x2*x22 - x22*x6 &
                 - x23*x5 + x7*(x18 + x19) + x9*(x20 - x21)
      wout(3) = -x11*(x26 + x27) + x12*x22 - x13*(x24 - x25) - x2*x23 - x22*x5 &
                 + x23*x6 + x7*(x24 + x25) - x9*(x26 - x27)
    else
      x0 = P1(2)*cima
      wout(0) = co(0)*(-P1(0)*w1(2) + P1(1)*w1(3) + P1(3)*w1(2) + w1(3)*x0)
      wout(1) = co(0)*(-P1(0)*w1(3) + P1(1)*w1(2) - P1(3)*w1(3) - w1(2)*x0)
      wout(2) = -co(1)*(P1(0)*w1(0) + P1(1)*w1(1) + P1(3)*w1(0) + w1(1)*x0)
      wout(3) = co(1)*(-P1(0)*w1(1) - P1(1)*w1(0) + P1(3)*w1(1) + w1(0)*x0)
    end if 
      end select 
    end subroutine treeFaF0
end module tcFaF0
