!******************************************************************************!
!                                                                              !
!    tcVVVV1.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVVV1.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2017                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2018-08-17 17:57             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVVV1
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec
  contains
    subroutine treeVVVV1(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVVV1)
!       Metric(1,4)*Metric(2,3)*c0
!       Metric(1,3)*Metric(2,4)*c1
!       Metric(1,2)*Metric(3,4)*c2
!       Epsilon(1,2,3,4)*c3
        if (last) VB_last = .true.
        x0 = w2(1)*w3(1)
        x1 = w2(2)*w3(2)
        x2 = w2(0)*w3(0)
        x3 = co(0)*(w2(3)*w3(3) + x0 + x1 - x2)
        x4 = w1(1)*w2(3)
        x5 = w1(3)*w2(1)
        x6 = x4 - x5
        x7 = co(3)*w3(2)
        x8 = w1(2)*w2(3)
        x9 = w1(3)*w2(2)
        x10 = co(3)*(x8 - x9)
        x11 = w1(1)*w2(2)
        x12 = w1(2)*w2(1)
        x13 = co(3)*(x11 - x12)
        x14 = w1(1)*w2(0)
        x15 = co(1)*w3(1)
        x16 = w1(2)*w2(0)
        x17 = co(1)*w3(2)
        x18 = w1(3)*w2(0)
        x19 = co(1)*w3(3)
        x20 = co(2)*w1(1)*w2(1)
        x21 = co(2)*w3(0)
        x22 = w1(0)*w2(3)
        x23 = -x18 + x22
        x24 = w1(0)*w2(2)
        x25 = -x16 + x24
        x26 = co(3)*w3(3)
        x27 = co(2)*w1(2)*w2(2)
        x28 = co(2)*w1(3)*w2(3)
        x29 = w1(0)*w2(1)
        x30 = co(1)*w3(0)
        x31 = co(2)*w1(0)*w2(0)
        x32 = -x14 + x29
        x33 = co(3)*w3(1)
        x34 = w1(3)*w2(3)*w3(3)
        wout(0) = -co(1)*w1(0)*x2 - co(2)*w1(0)*x2 + w1(0)*x3 + w1(2)*w2(2)*x21&
                   + w1(3)*w2(3)*x21 + w3(0)*x20 - w3(1)*x10 - w3(3)*x13 + x14*&
                  x15 + x16*x17 + x18*x19 + x6*x7
        wout(1) = co(1)*w1(1)*x0 + co(2)*w1(1)*x0 + w1(1)*x3 - w3(0)*x10 + w3(1&
                  )*x27 + w3(1)*x28 - w3(1)*x31 + x12*x17 + x19*x5 + x23*x7 -  &
                  x25*x26 - x29*x30
        wout(2) = co(1)*w1(2)*x1 + co(2)*w1(2)*x1 + co(3)*w3(0)*x6 + w1(2)*x3  &
                   + w3(2)*x20 + w3(2)*x28 - w3(2)*x31 + x11*x15 + x19*x9 - x23&
                  *x33 - x24*x30 + x26*x32
        wout(3) = co(1)*x34 + co(2)*x34 + w1(3)*x3 - w3(0)*x13 + w3(3)*x20 + w3&
                  (3)*x27 - w3(3)*x31 + x15*x4 + x17*x8 - x22*x30 + x25*x33 -  &
                  x32*x7
      end select 
    end subroutine treeVVVV1
end module tcVVVV1
